/**************************************************************************************
* *Copyright (c) 2006 Regents of the University of Chang Gung 						*
* *All rights reserved.													*
 *																*
 * Redistribution and use in source and binary forms, with or without						*
 * modification, are permitted provided that the following conditions					*
 * are met: 															*
 * 1. Redistributions of source code must retain the above copyright						*
 *    notice, this list of conditions and the following disclaimer.						*
 * 2. Redistributions in binary form must reproduce the above copyright					*
 *    notice, this list of conditions and the following disclaimer in the						*
 *    documentation and/or other materials provided with the distribution.					*
 * 3. All advertising materials mentioning features or use of this software					*
 *    must display the following acknowledgement:									*
 *	This product includes software developed by the Computer Systems					*
 *	Engineering Group at Lawrence Berkeley Laboratory.							*
 * 4. Neither the name of the University nor of the Laboratory may be used					*
 *    to endorse or promote products derived from this software without					*
 *    specific prior written permission.										*
 *5. If you have any problem about these codes, 									*
       please mail to antibanish@gmail.com or b9229008@stmail.cgu.edu.tw                    			*
**************************************************************************************/
#include "delay.h"
#include "connector.h"
#include "packet.h"
#include "random.h"
#include "mobilenode.h"

#include "arp.h" 
#include "ll.h"
#include "mac.h"
#include "mac-802_16.h"
#include "timer-802_16.h"
#include "packet-802_16.h"
#include "cmu-trace.h"
#include "rtp.h"   
#include "agent.h"
#include "basetrace.h"
#include "geographic.h"
//#include "calculate.h"
#define PDUSIZE 200;

extern TOMAC *CalMod;


BCID_List *BCID_head = NULL;
BCID_List *BCID_tail = NULL;
DL_MAP_IE *DL_MAP_IE_head = NULL;
DL_MAP_IE *DL_MAP_IE_tail = NULL;
UL_MAP_IE *UL_MAP_IE_head = NULL;
UL_MAP_IE *UL_MAP_IE_tail = NULL;
Lock *check_list = new Lock;
SS_Queue *ss_buf = new SS_Queue;
Queue_List *Queue_list = new Queue_List;
MacStatus State_ = MIDLE;
int BSID = 0;
int BCID_count = 0;
int SFID_count1 = 0;
int SFID_count2 = 0;
int SFID_count3 = 0;
int SFID_count4 = 0;
int SFID_count5 = 0;
int SFID_count6 = 0;
int SFID_count7 = 0;
int SFID_count8 = 0;
int SFID_count9 = 0;
int SFID_count10 = 0;
int BS_UL_BW = 0, Tmp_UL_BW = 0, CAC_UL = 0;
int BS_DL_BW = 0, Tmp_DL_BW = 0;
double frameLength_ = 0.005, symbolTime_ = 0.0001084, ttg_ = 0.00002941, rtg_ = 0.00002941;
int channelSize_ = 20, DL_symbolNum_ = 36, UL_symbolNum_ = 12, DL_subchannelNum_ = 60, UL_subchannelNum_ = 92;
double allocation_start_time = 0.0;
int xxx=0;
int seqno_=-1;
//FILE *out_1;

Mac802_16::Mac802_16() :Mac(), FrameTimer(this), PreambleTimer(this), ulmaptimer(this), dlmaptimer(this), 
                        mhSend_(this), mhRecv_(this), mhDefer_(this), BFt(this), resumeSSBurst(this),
						resumeBSBurst(this), SendUL(this), SendDL(this), SendBW(this),SendDCD_(this),SendUCD_(this)
{
	creatid = index_;
	pktBr_ = 0;
	pktRNGREQ_ = 0;
	pktRNGRSP_ = 0;
	pktULMAP_ = 0;
	pktDLMAP_ = 0;
    pktUCD_ = 0;
    pktDCD_ = 0;	
	pktTx_ = 0;
	pktBurst_ = 0;
	pktBSBurst_ = 0;	
	PDU_lock = 0;
	tx_state_ = rx_state_ = MAC_IDLE;
	state_ = MAC_IDLE;
	rx_state_ = MAC_IDLE;
	cw_=cw_bw = CW_MIN;

	if(creatid == 0)
	{
		if(channelSize_ == 10)
		{
			DL_subchannelNum_ = 30;
			UL_subchannelNum_ = 35;
		}
		else if(channelSize_ == 20)
		{
			DL_subchannelNum_ = 60;
			UL_subchannelNum_ = 92;
		}
		
		BS_UL_BW = UL_subchannelNum_;
		BS_DL_BW = DL_symbolNum_;
		Tmp_UL_BW = CAC_UL = BS_UL_BW;	
		FrameTimer.start(0);
	}
}  

void 
Mac802_16::recv(Packet* p, Handler* h)
{
	struct hdr_cmn *hdr = HDR_CMN(p);
	struct hdr_mac *mac_ = HDR_MAC(p);
	struct hdr_mac802_16 *mac16_ = HDR_MAC802_16(p);

	if(creatid!=BSID)
	{	
		if(check_list->check(creatid)==0)
		{		
			check_list->enque(creatid);
			check_list->unlock(creatid);		   		
			ss_buf->enque(creatid);	
			Queue_list->enque(creatid);
			sendRNGREQ(creatid);				
		}
	}

	if(hdr->direction() == hdr_cmn::UP)
	{
		if(creatid==BSID)
		{
			if(mac16_->HT==0)
			{
				if(hdr->ptype()==PT_UGS||hdr->ptype()==PT_rtPS||hdr->ptype()==PT_nrtPS
					||hdr->ptype()==PT_ertPS||hdr->ptype()==PT_BE||hdr->ptype()==PT_ACK)
				{
					if(mac_->macDA_==BSID)
					{
						printf("BS receive SS %d packet at %f\n",mac_->macSA_,Scheduler::instance().clock());	
						uptarget_->recv(p, (Handler*) 0); 
						return;
					}
				}
				if(mac16_->mmt==-1)
				{
					Packet::free(p);
					return;
				}
				else if(mac16_->mmt==1)
				{
					Packet::free(p);
					return;
				}
				else if(mac16_->mmt==2)
				{	
					Packet::free(p);
					return;
				}
				else if(mac16_->mmt==3) 
				{
					Packet::free(p);
					return;
				}
				else if(mac16_->mmt==4)	
				{
					struct rng_req_t *rngreq = HDR_MAC802_16_RNGREQ(p);									
					sendRNGRSP(rngreq->ssMACAddr, Insert_BCID(rngreq->ssMACAddr));
					Search_BCID_macSA(rngreq->ssMACAddr)->MC_t=CalMod->search(rngreq->ssMACAddr)->ToMod(CalMod->search(BSID)->x,CalMod->search(BSID)->y);
					state_=MAC_IDLE;		
					mac_log(p);
					return;		
				}
				else if(mac16_->mmt==5)
				{
					Packet::free(p);
					return;
				}
			}
			else if(mac16_->HT==1)
			{
				struct bw_req_t* bwreq = HDR_MAC802_16_BWREQ(p);
				int SFID_tmp;
				switch(bwreq->Type)
				{
					case 0x0:	
						if(Call_Admission_Control(bwreq->CID,PT_UGS,bwreq->BR)==true)
						{
							SFID_tmp=Insert_SFID(bwreq->CID,PT_UGS,UL);
							Search_SFID(SFID_tmp)->BW=bwreq->BR;
							//Search_SFID(SFID_tmp)->destIP=p->destIP;
							mac_log(p);
							return;
						}
						else
						{
							printf("BR fail\n");
							return;
						}
						break;
					case 0x1:	
						if(Call_Admission_Control(bwreq->CID,PT_ertPS,bwreq->BR)==true)
						{
							SFID_tmp=Insert_SFID(bwreq->CID,PT_ertPS,UL);
							Search_SFID(SFID_tmp)->BW=bwreq->BR;
							//Search_SFID(SFID_tmp)->destIP=p->destIP;									
							mac_log(p);
							return;
						}
						else
						{
							printf("BR fail\n");
							return;
						}
						break;
					case 0x2:	
						if(Call_Admission_Control(bwreq->CID,PT_rtPS,bwreq->BR)==true)
						{
							SFID_tmp=Insert_SFID(bwreq->CID,PT_rtPS,UL);
							Search_SFID(SFID_tmp)->BW=bwreq->BR;
							//Search_SFID(SFID_tmp)->destIP=p->destIP;									
							mac_log(p);
							return;
						}
						else
						{
							printf("BR fail\n");
							return;
						}
						break;
					case 0x3:	
						if(Call_Admission_Control(bwreq->CID,PT_nrtPS,bwreq->BR)==true)
						{
							SFID_tmp=Insert_SFID(bwreq->CID,PT_nrtPS,UL);
							Search_SFID(SFID_tmp)->BW=bwreq->BR;
							//Search_SFID(SFID_tmp)->destIP=p->destIP;								
							mac_log(p);
							return;
						}
						else
						{
							printf("BR fail\n");
							return;
						}
						break;
					case 0x4:	
						if(Call_Admission_Control(bwreq->CID,PT_BE,bwreq->BR)==true)
						{
							SFID_tmp=Insert_SFID(bwreq->CID,PT_BE,UL);
							Search_SFID(SFID_tmp)->BW=bwreq->BR;
							//Search_SFID(SFID_tmp)->destIP=p->destIP;									
							mac_log(p);
							return;
						}
						else
						{
							printf("BR fail\n");
							return;
						}
						break;
					default:   
						printf("Bandwidth request type doesn't specify\n"); 
						return;	
						break;		
				}
			}	
		}
		else
		{
			if(mac16_->HT==1)
			{
				Packet::free(p);	
				return;
			}
			else if(mac16_->HT==0)
			{
				if(hdr->ptype()==PT_UGS||hdr->ptype()==PT_rtPS||hdr->ptype()==PT_nrtPS
					||hdr->ptype()==PT_ertPS||hdr->ptype()==PT_BE||hdr->ptype()==PT_ACK)
				{	
					if(hdr->ptype()==PT_ACK) 
					{
						uptarget_->recv(p, (Handler*) 0);		
						return;
					}
					
					if(mac_->macSA_==BSID && Search_BCID(Search_TCID(mac16_->CID)->BCID)->srcIP==creatid)//Jessy
					{
						printf("SS %d Receive BS Packet at %f\n",creatid,Scheduler::instance().clock());
						uptarget_->recv(p, (Handler*) 0);
						return;
					}
					else
					{ 	
						Packet::free(p);
						return;
					}
				}
				
				if(mac16_->mmt==-1)	
				{
					
					mac_log(p);					
					return;
				}
				else if(mac16_->mmt==1)	
				{					
					mac_log(p);
					return;
				} 
				else if(mac16_->mmt==2)	
				{
					mac_log(p);
					return;
				}
				else if(mac16_->mmt==3)	
				{	
					if(mac_->macSA_==BSID)
					{				
						UL_MAP_IE* UL_MAP_IE_tmp;
						UL_MAP_IE_tmp = UL_MAP_IE_head;
						while(UL_MAP_IE_tmp != NULL && UL_MAP_IE_tmp->UIUC!=0xc)
						{	
							if(Search_BCID(UL_MAP_IE_tmp->CID)->srcIP==creatid)
							{
								ulmaptimer.start(
										allocation_start_time-Scheduler::instance().clock(),
										UL_MAP_IE_tmp->CID,
										UL_MAP_IE_tmp->Subchannel_number*UL_symbolNum_
									); 
							}
							UL_MAP_IE_tmp = UL_MAP_IE_tmp->next; 
						}
						mac_log(p);								
					}
					return;
				}
				else if(mac16_->mmt==4)	
				{
					if(creatid==mac16_->CID)
						Packet::free(p);					
					return;
				}
				else if(mac16_->mmt==5)	
				{
					struct rng_rsp_t *rngrsp = HDR_MAC802_16_RNGRSP(p);						
					if(Search_BCID(mac16_->CID)->srcIP==creatid)
					{
						check_list->set_response(rngrsp->SSMAC);
						mac_log(p);
					}
					return;
				}
			}	
		}
		sendUp(p);  
		return;
	}
	else
	{
		callback_ = h;
		if(creatid==BSID)
		{
			if(hdr->ptype()==PT_UGS||hdr->ptype()==PT_rtPS||hdr->ptype()==PT_nrtPS
					||hdr->ptype()==PT_ertPS||hdr->ptype()==PT_BE)
			{
				Queue_list->lookup(mac_->macDA_)->BCID=Search_BCID_macSA(mac_->macDA_)->BCID;
				switch(hdr->ptype())
				{
					case PT_UGS: 	
						Queue_list->lookup(mac_->macDA_)->UGS.enque(p);		
						if(Queue_list->lookup(mac_->macDA_)->UGS.Lock==0)
						{
							int SFID_tmp=Insert_SFID(Search_BCID_macSA(mac_->macDA_)->BCID,PT_UGS,DL);
							Search_SFID(SFID_tmp)->BW=Queue_list->lookup(mac_->macDA_)->UGS.byteLength();
							Search_SFID(SFID_tmp)->destIP=mac_->macDA_;
							Queue_list->lookup(mac_->macDA_)->UGS.Lock=1;
						}
						break;
					case PT_rtPS: 	
						Queue_list->lookup(mac_->macDA_)->rtPS.enque(p);
						if(Queue_list->lookup(mac_->macDA_)->rtPS.Lock==0)
						{
							int SFID_tmp=Insert_SFID(Search_BCID_macSA(mac_->macDA_)->BCID,PT_rtPS,DL);
							Search_SFID(SFID_tmp)->BW=Queue_list->lookup(mac_->macDA_)->rtPS.byteLength();
							Search_SFID(SFID_tmp)->destIP=mac_->macDA_;
							Queue_list->lookup(mac_->macDA_)->rtPS.Lock=1;
						}
						break;
					case PT_nrtPS:	
						Queue_list->lookup(mac_->macDA_)->nrtPS.enque(p);
						if(Queue_list->lookup(mac_->macDA_)->nrtPS.Lock==0)
						{
							int SFID_tmp=Insert_SFID(Search_BCID_macSA(mac_->macDA_)->BCID,PT_nrtPS,DL);
							Search_SFID(SFID_tmp)->BW=Queue_list->lookup(mac_->macDA_)->nrtPS.byteLength();
							Search_SFID(SFID_tmp)->destIP=mac_->macDA_;
							Queue_list->lookup(mac_->macDA_)->nrtPS.Lock=1;
						}
						break;
					case PT_ertPS:	
						Queue_list->lookup(mac_->macDA_)->ertPS.enque(p);
						if(Queue_list->lookup(mac_->macDA_)->ertPS.Lock==0)
						{
							int SFID_tmp=Insert_SFID(Search_BCID_macSA(mac_->macDA_)->BCID,PT_ertPS,DL);
							Search_SFID(SFID_tmp)->BW=Queue_list->lookup(mac_->macDA_)->ertPS.byteLength();
							Search_SFID(SFID_tmp)->destIP=mac_->macDA_;
							Queue_list->lookup(mac_->macDA_)->ertPS.Lock=1;
						}
						break;
					case PT_BE:		
						Queue_list->lookup(mac_->macDA_)->BE.enque(p);	
						if(Queue_list->lookup(mac_->macDA_)->BE.Lock==0)
						{
							int SFID_tmp=Insert_SFID(Search_BCID_macSA(mac_->macDA_)->BCID,PT_BE,DL);
							Search_SFID(SFID_tmp)->BW=Queue_list->lookup(mac_->macDA_)->BE.byteLength();
							Search_SFID(SFID_tmp)->destIP=mac_->macDA_;
							Queue_list->lookup(mac_->macDA_)->BE.Lock=1;
						}
						break;
					default:
						break;
				}	
				
				Scheduler& s = Scheduler::instance();				
				if(!abstract_)	s.schedule(&hRes_, &intr_, 0);			
			}
			else sendDown(p);
		}
		else
		{	
			if(hdr->ptype()==PT_UGS||hdr->ptype()==PT_rtPS||hdr->ptype()==PT_nrtPS
					||hdr->ptype()==PT_ertPS||hdr->ptype()==PT_BE)
			{
				switch(hdr->ptype())
				{	
					case PT_UGS:
						ss_buf->lookup(creatid)->UGS.enque(p);
						break;
					case PT_rtPS:
						ss_buf->lookup(creatid)->rtPS.enque(p);
						break;
					case PT_nrtPS:							
						ss_buf->lookup(creatid)->nrtPS.enque(p);	
						break;
					case PT_ertPS:							
						ss_buf->lookup(creatid)->ertPS.enque(p);	
						break;
					case PT_BE:						
						ss_buf->lookup(creatid)->BE.enque(p);		
						break;
					default:
						break;
				}
				
				if(check_list->RSPenable(creatid)==1)
				{ 
					if(ss_buf->lookup(creatid)->set_UGS==0) 
					{		
						if(ss_buf->lookup(creatid)->UGS.byteLength()!=0)
						{
							sendBWREQ(ss_buf->lookup(creatid)->UGS.byteLength()
								,Search_BCID_macSA(creatid)->BCID,PT_UGS, mac_->macDA_, creatid); 
							ss_buf->lookup(creatid)->set_UGS=1;
						}
					}
					if(ss_buf->lookup(creatid)->set_rtPS==0)
					{ 
						if(ss_buf->lookup(creatid)->rtPS.byteLength()!=0)
						{
							sendBWREQ(ss_buf->lookup(creatid)->rtPS.byteLength()
								,Search_BCID_macSA(creatid)->BCID,PT_rtPS, mac_->macDA_, creatid);
							ss_buf->lookup(creatid)->set_rtPS=1;
						}	
					}
					if(ss_buf->lookup(creatid)->set_ertPS==0)
					{ 
						if(ss_buf->lookup(creatid)->ertPS.byteLength()!=0)
						{
							sendBWREQ(ss_buf->lookup(creatid)->ertPS.byteLength()
								,Search_BCID_macSA(creatid)->BCID,PT_ertPS, mac_->macDA_, creatid);
							ss_buf->lookup(creatid)->set_ertPS=1;
						}
					}				
					if(ss_buf->lookup(creatid)->set_nrtPS==0)
					{
						if(ss_buf->lookup(creatid)->nrtPS.byteLength()!=0)
						{
							sendBWREQ(ss_buf->lookup(creatid)->nrtPS.byteLength()
								,Search_BCID_macSA(creatid)->BCID,PT_nrtPS, mac_->macDA_, creatid);
							ss_buf->lookup(creatid)->set_nrtPS=1;
						}
					}				
					if(ss_buf->lookup(creatid)->set_BE==0) 
					{
						if(ss_buf->lookup(creatid)->BE.byteLength()!=0)
						{
							sendBWREQ(ss_buf->lookup(creatid)->BE.byteLength()*10
								,Search_BCID_macSA(creatid)->BCID,PT_BE, mac_->macDA_, creatid); 
							ss_buf->lookup(creatid)->set_BE=1;
						}
					}			
				}
				
				Scheduler& s = Scheduler::instance();				
				if(!abstract_)	s.schedule(&hRes_, &intr_, 0);		
			}
			else	sendDown(p);
		}
		return;
	}
}

void 
Mac802_16::sendDCD()
{
	Packet *p= Packet::alloc();	
	struct hdr_cmn *hdr = HDR_CMN(p);
	struct hdr_mac *mac_ =HDR_MAC(p);
	struct hdr_mac802_16* mac16_ =HDR_MAC802_16(p);
	struct DCD *dcd_=HDR_MAC802_16_DCD(p);
	hdr->txtime() = 0.0001;
	hdr->uid() = 0;
    hdr->ptype() = PT_DCD;
    hdr->size() = 24;
    hdr->iface() = -2;
    hdr->error() = 0; 
	
	mac_->macDA_=MAC_BROADCAST;
	mac_->macSA_=creatid;	
	
	mac16_->HT =0;
	mac16_->EC =1;
	mac16_->type=1;
	mac16_->CI=1; 
	mac16_->EKS=1;
	mac16_->LEN=3;
	mac16_->CID=0; 
	mac16_->HCS=0;
	mac16_->mmt=1;
	
	dcd_->Configuration_Change_Count=0;
	dcd_->downlink_channel_id=0;
	dcd_->management_message_type=1;
	
	pktDCD_=p;	
}

void 
Mac802_16::sendUCD()
{
	Packet *p= Packet::alloc();	
	struct hdr_cmn *hdr = HDR_CMN(p);
	struct hdr_mac *mac_ = HDR_MAC(p);
	struct hdr_mac802_16 *mac16_ =HDR_MAC802_16(p);
	struct UCD *ucd_=HDR_MAC802_16_UCD(p);
	hdr->txtime() = 0.0001;
	hdr->uid() = 0;
    hdr->ptype() = PT_UCD;
    hdr->size() = 24;
    hdr->iface() = -2;
    hdr->error() = 0; 

	mac_->macDA_=MAC_BROADCAST;
	mac_->macSA_=creatid;
	
	mac16_->HT =0;
	mac16_->EC =1;
	mac16_->type=1;
	mac16_->CI=1; 
	mac16_->EKS=1;
	mac16_->LEN=3;
	mac16_->CID=0; 
	mac16_->HCS=0;
	mac16_->mmt=-1;
	
	ucd_->Configuration_Change_Count=0;
	ucd_->rng_backoff_start=0;
	ucd_->rng_backoff_end=0;
	ucd_->req_backoff_start=0;
	ucd_->req_backoff_end=0;
	
	pktUCD_=p;	
}

void 
Mac802_16::sendRNGREQ(int SA)
{ 
	printf("SS %d is sending RNGREQ to BS\n",creatid);
	Packet* p= Packet::alloc();
	
	struct hdr_cmn *hdr = HDR_CMN(p);
	struct hdr_mac* mac_ = HDR_MAC(p); 
	struct hdr_mac802_16* mac16_ =HDR_MAC802_16(p);
	struct rng_req_t* rngreq = HDR_MAC802_16_RNGREQ(p);	 
	
	mac_->macDA_ = BSID;
	mac_->macSA_ = SA;
	
	hdr->txtime() = 0.0001;
	hdr->uid() = 0;
    hdr->ptype() = PT_RNGREQ;
    hdr->size() = 10;
    hdr->iface() = -2;
    hdr->error() = 0; 
	//generic mac header
	mac16_->HT =0;
	mac16_->EC =1;
	mac16_->type=1;
	mac16_->CI=1; 
	mac16_->EKS=1;
	mac16_->LEN=3;
	mac16_->CID=0;
	mac16_->HCS=0;
	mac16_->mmt=4; 

	rngreq->downlinkchannelid = 1;
	rngreq->ReqDownlinkBurPro = 1;
	rngreq->ssMACAddr = SA;
	rngreq->MACver =16;
	
	pktRNGREQ_=p;
	BFt.start(cw_,State_,symbolTime_);	
}

void 
Mac802_16::sendRNGRSP(int ssmac,int BSCID)
{
	printf("BS is sending RNGRSP to SS %d\n",BSCID);
	Packet* p= Packet::alloc();	
	struct hdr_cmn *hdr = HDR_CMN(p);
	struct hdr_mac* mac_ = HDR_MAC(p); 
	struct hdr_mac802_16* mac16_ =HDR_MAC802_16(p);
	struct rng_rsp_t* rngrsp = HDR_MAC802_16_RNGRSP(p);
	
	mac_->macDA_=ssmac;
	mac_->macSA_=BSID;
	
	hdr->txtime() = 0.0001;
	hdr->uid() = 0;
    hdr->ptype() = PT_RNGRSP;
    hdr->size() = 24;
    hdr->iface() = -2;
    hdr->error() = 0; 
	
	mac16_->HT =0;
	mac16_->EC =1;
	mac16_->type=1;
	mac16_->CI=1; 
	mac16_->EKS=1;
	mac16_->LEN=3;
	mac16_->CID=BSCID; 
	mac16_->HCS=0;
	mac16_->mmt=5; 		
	
	rngrsp->BasicCID = BSCID;
	rngrsp->SSMAC = ssmac;
	rngrsp->RNGstatus = 0;
	rngrsp->uplinkchannelid=0;
	rngrsp->RNGstatus=0;
	rngrsp->PriManCID=0;	
	rngrsp->FrameNum=0;
	rngrsp->IniRNGOpp=0;	
	
	pktRNGRSP_=p;
    transmit(pktRNGRSP_,0);
}

void 
Mac802_16::sendBWREQ(int BR, int CID, packet_t pype, int DA, int SA)
{
	Packet* p= Packet::alloc();
	//p->destIP=DA;
	struct hdr_cmn *hdr = HDR_CMN(p);
	struct hdr_mac802_16* mac16_ =HDR_MAC802_16(p);	
	struct bw_req_t* br =HDR_MAC802_16_BWREQ(p) ;
	struct hdr_mac* mac_ = HDR_MAC(p); 
	
	mac_->macDA_ = BSID;
	mac_->macSA_ = SA;
	
	hdr->txtime() = 0.000002;
	hdr->uid() = 0;
    hdr->ptype() = PT_BWREQ;
    hdr->size() = 24;
    hdr->iface() = -2;
    hdr->error() = 0;
	
	mac16_->HT =1;	
	mac16_->type=1;
	mac16_->CI=1; 
	mac16_->EKS=1;	
	
	br->HT =1;
	br->EC =0;
	br->BR =BR;	
	br->CID=Search_BCID_macSA(SA)->BCID; 
	br->HCS=1;
	
	switch(pype){	
		case PT_UGS:	
			br->Type=0x0;   
			printf("SS %d is send UGS Bandwidth Request to BS\n",this->creatid); 	
			break;
		case PT_ertPS: 	
			br->Type=0x1;	
			printf("SS %d is send ertPS Bandwidth Request BS\n",this->creatid);    	
			break;
		case PT_rtPS: 	
			br->Type=0x2; 	
			printf("SS %d is send rtPS Bandwidth Request BS\n",this->creatid);		
			break;
		case PT_nrtPS: 	
			br->Type=0x3; 	
			printf("SS %d is send nrtPS Bandwidth Request BS\n",this->creatid);		
			break;
		case PT_BE: 	
			br->Type=0x4;   
			printf("SS %d is send BE Bandwidth Request BS\n",this->creatid);		
			break;
		default: 
			break;
	}  
	
	pktBr_=p;
	SendBW.start(cw_bw,State_,symbolTime_);
}

bool 
Mac802_16::Call_Admission_Control(int BCID,packet_t ptype,int BR_BW)
{
	int symbolNum_ = 0;
	int symbolSize_ = 0;
	switch(Search_BCID(BCID)->MC_t)
	{
		case QPSK_12:
			symbolSize_ = 6;
			break;
		case QPSK_34:
			symbolSize_ = 9;
			break;
		case QAM16_12:
			symbolSize_ = 12;
			break;
		case QAM16_34:
			symbolSize_ = 18;
			break;
		case QAM64_23:
			symbolSize_ = 24;
			break;
		case QAM64_34:
			symbolSize_ = 27;
		default:
			break;
	}
					
	if(BR_BW%symbolSize_ != 0)
		symbolNum_ = (int)(BR_BW/symbolSize_) + 1;
	else
		symbolNum_ = (int)(BR_BW/symbolSize_);	
		
	if(symbolNum_%UL_symbolNum_!=0)	
	{
		if(CAC_UL - ((int)(symbolNum_/UL_symbolNum_) + 1) >= 0)
		{
			CAC_UL -= ((int)(symbolNum_/UL_symbolNum_) + 1);
			printf("BS Remainder Uplink Bandwidth %d OFDMA symbols\n",CAC_UL*UL_symbolNum_);
			return true;
		}
		else
		{
			return false;
		}
	}
	else
	{
		if(CAC_UL - (int)(symbolNum_/UL_symbolNum_) >= 0)
		{
			CAC_UL -= (int)(symbolNum_/UL_symbolNum_);
			printf("BS Remainder Uplink Bandwidth %d OFDMA symbols\n",CAC_UL*UL_symbolNum_);	
			return true;
		}
		else
		{
			return false;
		}
	}
}

void 
Mac802_16::Bandwidth_Management()
{
	int SS_DL_BW = 0, SS_UL_BW = 0;
	int symbolNum_ = 0;
	int symbolSize_ = 0;
	BCID_List *BCID_tmp = NULL;
	SFID_List *SFID_tmp = NULL;
	DL_MAP_IE *DL_MAP_IE_tmp = NULL;
	UL_MAP_IE *UL_MAP_IE_tmp = NULL;
	ModulCoding_t MC_t;

  /*************** Downlink ***************/	
	/* DL-MAP and UL-MAP use 2 OFDMA symbols respectively */
	Tmp_DL_BW = BS_DL_BW - 4;
	MC_t = QPSK_12;
	BCID_tmp=BCID_head;
	
Downlink_:	
	while(BCID_tmp != NULL)
	{
		SFID_tmp = BCID_tmp->SF;
		BCID_tmp->SS_DL_BW = 0;
		
		/* Sum of bandwidth of downlink service flow for this SS */
		while(SFID_tmp != NULL)
		{
			if(SFID_tmp->SFID%10 == 5)
				BCID_tmp->SS_DL_BW += SFID_tmp->BW;
			else if(SFID_tmp->SFID%10 == 6)
				BCID_tmp->SS_DL_BW += SFID_tmp->BW;
			else if(SFID_tmp->SFID%10 == 7)
				BCID_tmp->SS_DL_BW += SFID_tmp->BW;
			else if(SFID_tmp->SFID%10 == 8)
				BCID_tmp->SS_DL_BW += SFID_tmp->BW;
			else if(SFID_tmp->SFID%10 == 9)
				BCID_tmp->SS_DL_BW += SFID_tmp->BW;
			SFID_tmp = SFID_tmp->next;
		}
		
		/* Setting symbol size of this SS */
		switch(BCID_tmp->MC_t)
		{
			case QPSK_12:
				symbolSize_ = 6;
				break;
			case QPSK_34:
				symbolSize_ = 9;
				break;
			case QAM16_12:
				symbolSize_ = 12;
				break;
			case QAM16_34:
				symbolSize_ = 18;
				break;
			case QAM64_23:
				symbolSize_ = 24;
				break;
			case QAM64_34:
				symbolSize_ = 27;
				break;
			default:
				break;
			}
			
		/* Convert downlink bandwidth of this SS into number of symbol */	
		if(BCID_tmp->SS_DL_BW%symbolSize_ != 0)
			symbolNum_ = (int)(BCID_tmp->SS_DL_BW/symbolSize_) + 1;
		else
			symbolNum_ = (int)(BCID_tmp->SS_DL_BW/symbolSize_);
		
		/* Convert number of symbol into number of symbol time where 2 symbols are one slot in PUSC permntation */
		if( (int)(symbolNum_/DL_subchannelNum_)==0)	
		{
			SS_DL_BW = 2;
		}
		else
		{
			if(SS_DL_BW%2!=0)
				SS_DL_BW = (int)(symbolNum_/DL_subchannelNum_)+1;
			else
				SS_DL_BW = (int)(symbolNum_/DL_subchannelNum_);
		}
		
		/* Collect the same modulation of SS into the same burstprofile */
		if(BCID_tmp->MC_t == MC_t)
		{
			/* Check out whether BS has enought downlnk bandwidth to service this SS */
			if(BCID_tmp->SS_DL_BW > 0 && Tmp_DL_BW - SS_DL_BW >= 0)
			{					
				DL_MAP_IE_tmp = new DL_MAP_IE;
				DL_MAP_IE_tmp->CID = BCID_tmp->BCID;
				DL_MAP_IE_tmp->OFDMA_Symbol_number = SS_DL_BW;
				Tmp_DL_BW -= SS_DL_BW;
			
				/* Set DIUC value of this UL_MAP_IE */
				switch(BCID_tmp->MC_t)
				{
					case QPSK_12:
						DL_MAP_IE_tmp->DIUC = 0x1;
						break;
					case QPSK_34:
						DL_MAP_IE_tmp->DIUC = 0x2;
						break;
					case QAM16_12:
						DL_MAP_IE_tmp->DIUC = 0x3;
						break;
					case QAM16_34:
						DL_MAP_IE_tmp->DIUC = 0x4;
						break;
					case QAM64_23:
						DL_MAP_IE_tmp->DIUC = 0x5;
						break;
					case QAM64_34:
						DL_MAP_IE_tmp->DIUC = 0x6;
						break;
					default:
						break;
				}
			
				/* Insert DL_MAP_IE into DL_MAP_IE link list */
				if(DL_MAP_IE_head == NULL)
				{
					DL_MAP_IE_head = DL_MAP_IE_tail = DL_MAP_IE_tmp;
					DL_MAP_IE_tail->next = NULL;
				}
				else
				{
					DL_MAP_IE_tail->next = DL_MAP_IE_tmp;
					DL_MAP_IE_tail = DL_MAP_IE_tmp;	
					DL_MAP_IE_tail->next = NULL;
				}
			}
		}
		
		if(BCID_tmp->next == NULL)
		{
			BCID_tmp = BCID_head;
			
			switch(MC_t)
			{
				case QPSK_12:
					MC_t = QPSK_34;
					break;
				case QPSK_34:
					MC_t = QAM16_12;
					break;
				case QAM16_12:
					MC_t = QAM16_34;
					break;
				case QAM16_34:
					MC_t = QAM64_23;
					break;
				case QAM64_23:
					MC_t = QAM64_34;
					break;
				case QAM64_34:
					BCID_tmp = NULL;
					break;
				default:
					break;
				goto Downlink_;
			}
		}
		else
		{
			BCID_tmp = BCID_tmp->next;		
		}
	}	

	sendDLMAP();
	
  /*************** Uplink ***************/
	Tmp_UL_BW = BS_UL_BW;
	MC_t = QPSK_12;
	BCID_tmp = BCID_head;

Uplink_:	
	while(BCID_tmp!=NULL)
	{
		SFID_tmp=BCID_tmp->SF;
		BCID_tmp->SS_UL_BW = 0;
		
		/* Sum of bandwidth of downlink service flow for this SS */
		while(SFID_tmp!=NULL)
		{
			if(SFID_tmp->SFID%10==0)
				BCID_tmp->SS_UL_BW += SFID_tmp->BW;
			else if(SFID_tmp->SFID%10==1)
				BCID_tmp->SS_UL_BW += SFID_tmp->BW;
			else if(SFID_tmp->SFID%10==2)
				BCID_tmp->SS_UL_BW += SFID_tmp->BW;
			else if(SFID_tmp->SFID%10==3)
				BCID_tmp->SS_UL_BW += SFID_tmp->BW;
			else if(SFID_tmp->SFID%10==4)
				BCID_tmp->SS_UL_BW += SFID_tmp->BW;
			SFID_tmp=SFID_tmp->next;
		}
		
		/* Setting symbol size of this SS */
		switch(BCID_tmp->MC_t)
		{
			case QPSK_12:
				symbolSize_ = 6;
				break;
			case QPSK_34:
				symbolSize_ = 9;
				break;
			case QAM16_12:
				symbolSize_ = 12;
				break;
			case QAM16_34:
				symbolSize_ = 18;
				break;
			case QAM64_23:
				symbolSize_ = 24;
				break;
			case QAM64_34:
				symbolSize_ = 27;
				break;
			default:
				break;
		}
		
		/* Convert downlink bandwidth of this SS into number of symbol */	
		if(BCID_tmp->SS_UL_BW%symbolSize_!=0)
			symbolNum_ = (int)(BCID_tmp->SS_UL_BW/symbolSize_)+1;
		else
			symbolNum_ = (int)(BCID_tmp->SS_UL_BW/symbolSize_);	
		
		/* Convert number of symbol into number of subchannel where 3 symbols are one slot in PUSC permntation */
		if( (int)(symbolNum_/UL_symbolNum_)==0)	
		{
			SS_UL_BW = 1;
		}
		else
		{
			if(symbolNum_%UL_symbolNum_!=0)
				SS_UL_BW = (int)(symbolNum_/UL_symbolNum_)+1;
			else
				SS_UL_BW = (int)(symbolNum_/UL_symbolNum_);
		}
		
		/* Collect the same modulation of SS into the same burstprofile */
		if(BCID_tmp->MC_t == MC_t)
		{
			/* Check out whether BS has enought uplink bandwidth to service this SS */
			if(BCID_tmp->SS_UL_BW > 0 && Tmp_UL_BW - SS_UL_BW >= 0)
			{
				UL_MAP_IE_tmp = new UL_MAP_IE;
				UL_MAP_IE_tmp->CID = BCID_tmp->BCID;
				UL_MAP_IE_tmp->Subchannel_number = SS_UL_BW;
				Tmp_UL_BW -= SS_UL_BW;
				CAC_UL = Tmp_UL_BW;
			
				/* Set UIUC value of this UL_MAP_IE */
				switch(BCID_tmp->MC_t)
				{
					case QPSK_12:
						UL_MAP_IE_tmp->UIUC = 0x1;
						break;
					case QPSK_34:
						UL_MAP_IE_tmp->UIUC = 0x2;
						break;
					case QAM16_12:
						UL_MAP_IE_tmp->UIUC = 0x3;
						break;
					case QAM16_34:
						UL_MAP_IE_tmp->UIUC = 0x4;
						break;
					case QAM64_23:
						UL_MAP_IE_tmp->UIUC = 0x5;
						break;
					case QAM64_34:
						UL_MAP_IE_tmp->UIUC = 0x6;
						break;
					default:
						break;
				}
			
				/* Insert UL_MAP_IE into UL_MAP_IE link list */
				if(UL_MAP_IE_head == NULL)
				{
					UL_MAP_IE_head = UL_MAP_IE_tail = UL_MAP_IE_tmp;
					UL_MAP_IE_tail->next = NULL;
				}
				else
				{
					UL_MAP_IE_tail->next = UL_MAP_IE_tmp;
					UL_MAP_IE_tail = UL_MAP_IE_tmp;	
					UL_MAP_IE_tail->next = NULL;
				}
			}
		}
			
		if(BCID_tmp->next == NULL)
		{
			BCID_tmp = BCID_head;
			
			switch(MC_t)
			{
				case QPSK_12:
					MC_t = QPSK_34;
					break;
				case QPSK_34:
					MC_t = QAM16_12;
					break;
				case QAM16_12:
					MC_t = QAM16_34;
					break;
				case QAM16_34:
					MC_t = QAM64_23;
					break;
				case QAM64_23:
					MC_t = QAM64_34;
					break;
				case QAM64_34:
					BCID_tmp = NULL;
					break;
				default:
					break;
				goto Uplink_;
			}
		}
		else
		{
			BCID_tmp = BCID_tmp->next;		
		}
	}
	
	sendULMAP();
}

void 
Mac802_16::sendDLMAP()
{
	Packet *p = Packet::alloc();
	struct hdr_cmn *hdr = HDR_CMN(p);
	struct hdr_mac *mac_ = HDR_MAC(p);
	struct hdr_mac802_16 *mac_16 = HDR_MAC802_16(p);
	struct DL_MAP *dlmap = HDR_MAC802_16_DL_MAP(p);
	DL_MAP_IE *DL_MAP_IE_tmp = NULL;
	
	mac_->macDA_ = MAC_BROADCAST;
	mac_->macSA_ = creatid;
	
	hdr->txtime() = 0.000001;
	hdr->uid() = 0;
	hdr->ptype() = PT_DLMAP;
	hdr->size() = 10;
	hdr->iface() = -2;
	hdr->error() = 0; 
	
	mac_16->HT = 0;
	mac_16->EC = 1;
	mac_16->type = 1;
	mac_16->CI = 1; 
	mac_16->EKS = 1;
	mac_16->LEN = 3;
	mac_16->CID = 0; 
	mac_16->HCS = 0;
	mac_16->mmt = 2; 		
	
	dlmap->management_message_type = 2;
	dlmap->BS_ID = 0;	
	
	pktDLMAP_ = p;
	SendDL.start(0);	
	
	if(DL_MAP_IE_head != NULL)
	{
		DL_MAP_IE_tmp = DL_MAP_IE_head;
		DL_MAP_IE_tmp->OFDMA_Symbol_offset = 0x0;
		DL_MAP_IE_tmp->Subchannel_offset = 0x0;
		DL_MAP_IE_tmp->Subchannel_number = DL_subchannelNum_;
		
		/* Start DL_MAP timer where first transmission should wait DL-map and UL-map send out (4 symbol time) */
		dlmaptimer.start(4*symbolTime_, DL_MAP_IE_tmp->CID, DL_MAP_IE_tmp->OFDMA_Symbol_number);
	}
	else 
	{
		DL_MAP_IE_tmp = new DL_MAP_IE;
		DL_MAP_IE_tmp->DIUC = 0xe;
		DL_MAP_IE_head = DL_MAP_IE_tail = DL_MAP_IE_tmp;
		DL_MAP_IE_tail->next = NULL;
	}
}

void 
Mac802_16::DLmapHandler(double time, int BCID, int symbolOffset)
{	
	DL_MAP_IE *DL_MAP_IE_tmp = NULL, *DL_MAP_IE_backup = NULL;
	
	DL_MAP_IE_tmp = DL_MAP_IE_head;
	
	while(DL_MAP_IE_tmp != NULL)
	{
		if(DL_MAP_IE_tmp->CID == BCID)
		{
			BS_Scheduler(BCID, DL_MAP_IE_tmp->OFDMA_Symbol_number*DL_MAP_IE_tmp->Subchannel_number);   
			DL_MAP_IE_backup = DL_MAP_IE_tmp;
			goto Schedule_;
		}
		DL_MAP_IE_tmp = DL_MAP_IE_tmp->next; 
	}	
	
Schedule_:
	if(DL_MAP_IE_tmp->next != NULL)
	{	
		DL_MAP_IE_tmp = DL_MAP_IE_tmp->next;
		DL_MAP_IE_tmp->OFDMA_Symbol_offset = symbolOffset;
		DL_MAP_IE_tmp->Subchannel_offset = 0x0;
		DL_MAP_IE_tmp->Subchannel_number = DL_subchannelNum_;
		
		/* Start DL_MAP timer where the next transmission should wait for the last transmission send out */
		dlmaptimer.start(
				DL_MAP_IE_backup->OFDMA_Symbol_number*symbolTime_, 
				DL_MAP_IE_tmp->CID, 
				symbolOffset+DL_MAP_IE_tmp->OFDMA_Symbol_number
			);
	}
	else
	{	
		DL_MAP_IE_tmp = new DL_MAP_IE;
		DL_MAP_IE_tmp->DIUC = 0xe;
		DL_MAP_IE_tail->next = DL_MAP_IE_tmp;
		DL_MAP_IE_tail = DL_MAP_IE_tmp;	
		DL_MAP_IE_tail->next = NULL;
		dlmaptimer.stop();
	}
}

void 
Mac802_16::sendULMAP()
{
	Packet *p = Packet::alloc();
	struct hdr_cmn *hdr = HDR_CMN(p);
	struct hdr_mac *mac_ = HDR_MAC(p);
	struct hdr_mac802_16 *mac_16 = HDR_MAC802_16(p);
	struct UL_MAP *ulmap = HDR_MAC802_16_UL_MAP(p);
	int subchannelOffset_ = 0;
	UL_MAP_IE* UL_MAP_IE_tmp = NULL;
	
	mac_->macDA_ = MAC_BROADCAST;
	mac_->macSA_ = creatid;
	
	hdr->txtime() = 0.000001;
	hdr->uid() = 0;
	hdr->ptype() = PT_ULMAP;
	hdr->size() = 10;
	hdr->iface() = -2;
	hdr->error() = 0; 
	
	mac_16->HT = 0;
	mac_16->EC = 1;
	mac_16->type = 1;
	mac_16->CI = 1; 
	mac_16->EKS = 1;
	mac_16->LEN = 3;
	mac_16->CID = 0; 
	mac_16->HCS = 0;
	mac_16->mmt = 3; 	
	
	ulmap->management_message_type = 3;
	ulmap->uplink_channel_id = 1;
	
	allocation_start_time = Scheduler::instance().clock() + symbolTime_*36 + ttg_;	
	
	UL_MAP_IE_tmp = UL_MAP_IE_head;
	
	while(UL_MAP_IE_tmp != NULL)
	{
		UL_MAP_IE_tmp->OFDMA_Symbol_offset = 0x0;
		UL_MAP_IE_tmp->Subchannel_offset = subchannelOffset_;
		subchannelOffset_ += UL_MAP_IE_tmp->Subchannel_number;		
		UL_MAP_IE_tmp = UL_MAP_IE_tmp->next;
	}
	
	/* Insert end of UL_MAP_IE into UL_MAP_IE link list */
	if(UL_MAP_IE_head==NULL)
	{
		UL_MAP_IE_tmp = new UL_MAP_IE;
		UL_MAP_IE_tmp->UIUC = 0xc;
		UL_MAP_IE_head = UL_MAP_IE_tail = UL_MAP_IE_tmp;
		UL_MAP_IE_tail->next = NULL;
	}
	else
	{
		UL_MAP_IE_tmp = new UL_MAP_IE;
		UL_MAP_IE_tmp->UIUC = 0xc;
		UL_MAP_IE_tail->next = UL_MAP_IE_tmp;
		UL_MAP_IE_tail = UL_MAP_IE_tmp;	
		UL_MAP_IE_tail->next = NULL;
	}
	
	pktULMAP_=p;
	SendUL.start(2*symbolTime_);
}

void 
Mac802_16::BS_Scheduler(int BCID, int Symbol_number)
{
	BCID_List *BCID_tmp = Search_BCID(BCID);
	SFID_List *SFID_tmp = NULL;
	int All_UGS_BW = -1, All_ertPS_BW = -1, All_rtPS_BW = -1, All_nrtPS_BW = -1, All_BE_BW = -1;
	int symbolSize_ = 0, BW = 0, UGS_BW = 0, ertPS_BW = 0, rtPS_BW = 0, nrtPS_BW = 0, BE_BW = 0;
	int UGS_queue = Queue_list->Search_BCID(BCID)->UGS.byteLength();
	int ertPS_queue = Queue_list->Search_BCID(BCID)->ertPS.byteLength();
	int rtPS_queue = Queue_list->Search_BCID(BCID)->rtPS.byteLength();
	int nrtPS_queue = Queue_list->Search_BCID(BCID)->nrtPS.byteLength();
	int BE_queue = Queue_list->Search_BCID(BCID)->BE.byteLength();
	int count = 0;
	double q5 = 0.30, q4 = 0.30, q3 = 0.30, q2 = 0.05, q1 = 0.05;
	
	if(BCID_tmp != NULL)
	{
		SFID_tmp = BCID_tmp->SF;
		
		/* Sum of bandwidth of uplink service flow for this SS */
		while(SFID_tmp != NULL)
		{	
			if(SFID_tmp->SFID%10 == 5)
				All_UGS_BW += SFID_tmp->BW;
			else if(SFID_tmp->SFID%10 == 6)
				All_ertPS_BW += SFID_tmp->BW;
			else if(SFID_tmp->SFID%10 == 7)
				All_rtPS_BW += SFID_tmp->BW;
			else if(SFID_tmp->SFID%10 == 8)
				All_nrtPS_BW += SFID_tmp->BW;
			else if(SFID_tmp->SFID%10 == 9)
				All_BE_BW += SFID_tmp->BW;
			SFID_tmp = SFID_tmp->next;	
		}
		
		switch(BCID_tmp->MC_t)
		{
			case QPSK_12:
				symbolSize_ = 6;
				break;
			case QPSK_34:
				symbolSize_ = 9;
				break;
			case QAM16_12:
				symbolSize_ = 12;
				break;
			case QAM16_34:
				symbolSize_ = 18;
				break;
			case QAM64_23:
				symbolSize_ = 24;
				break;
			case QAM64_34:
				symbolSize_ = 27;
				break;
			default:
				break;
		}
		
		BW = symbolSize_*Symbol_number;
	}
	
	/* [QoS] Allocate downlink bandwidth to UGS traffic where it  equals  to the bandwidth at least that SS requested */
	if(All_UGS_BW != -1) 
	{
		if(UGS_queue > All_UGS_BW)
			UGS_BW = All_UGS_BW + 1;
		else
			UGS_BW = UGS_queue;
		BW -= UGS_BW;
	}
	
	/* [QoS] Allocate downlink bandwidth to ertPS traffic where it  equals  to the bandwidth at least that SS requested */
	if(All_ertPS_BW != -1) 
	{
		if(ertPS_queue > All_ertPS_BW)
			ertPS_BW = All_ertPS_BW + 1;
		else
			ertPS_BW = ertPS_queue;
		BW -= ertPS_BW;
	}
	
	/* [QoS] Allocate downlink bandwidth to rtPS traffic where it  equals  to the bandwidth at least that SS requested */
	if(All_rtPS_BW != -1) 
	{
		if(rtPS_queue > All_rtPS_BW)
			rtPS_BW = All_rtPS_BW + 1;
		else
			rtPS_BW = rtPS_queue;
		BW -= rtPS_BW;
	}
	
	/* [QoS] Allocate downlink bandwidth to nrtPS traffic where it  equals  to the bandwidth at least that SS requested */
	if(All_nrtPS_BW != -1) 
	{
		if(nrtPS_queue > All_nrtPS_BW)
			nrtPS_BW = All_nrtPS_BW + 1;
		else
			nrtPS_BW = nrtPS_queue;
		BW -= nrtPS_BW;
	}
	
	/* [QoS] Allocate downlink bandwidth to BE traffic where it  equals  to the bandwidth at least that SS requested */
	if(All_BE_BW != -1) 
	{
		if(BE_queue > All_BE_BW)
			BE_BW = All_BE_BW;
		else
			BE_BW = BE_queue;
		BW -= BE_BW;
	}
	
	/* Allocate remainder downlink bandwidth */
	while(BW > 0 && count < 5)
	{
		/* Allocate 100*q5 bytes to UGS traffic */
		if(UGS_queue != -1 && BW != 0) 
		{
			if(BW - (int)(100*q5) < 0) 
			{
				UGS_BW += BW;
				BW = 0;
			} 
			else 
			{
				UGS_BW += (int)(100*q5);
				BW -= (int)(100*q5);
			}
		}
	
		/* Allocate 100*q4 bytes to ertPS traffic */
		if(ertPS_queue != 0 && BW != 0) 
		{
			if(BW - (int)(100*q4) < 0) 
			{
				ertPS_BW += BW;
				BW = 0;
			} 
			else 
			{
				ertPS_BW += (int)(100*q4);
				BW -= (int)(100*q4);
			}
		}
	
		/* Allocate 100*q3 bytes to rtPS traffic */
		if(rtPS_queue != 0 && BW != 0) 
		{
			if(BW - (int)(100*q3) < 0) 
			{
				rtPS_BW += BW;
				BW = 0;
			} 
			else 
			{
				rtPS_BW +=  (int)(100*q3);
				BW -= (int)(100*q3);
			}
		}
		
		/* Allocate 100*q2 bytes to nrtPS traffic */
		if(nrtPS_queue != 0 && BW != 0) 
		{
			if(BW - (int)(100*q2) < 0) 
			{
				nrtPS_BW += BW;
				BW = 0;
			} 
			else
			{
				nrtPS_BW +=  (int)(100*q2);
				BW -= (int)(100*q2);
			}
		}
		
		/* Allocate 100*q1 bytes to BE traffic */
		if(BE_queue != 0 && BW != 0) 
		{
			if(BW - (int)(100*q1) < 0) 
			{
				BE_BW += BW;
				BW = 0;
			} 
			else 
			{
				BE_BW +=  (int)(100*q1);
				BW -= (int)(100*q1);
			}
		}
		count++;
	}
	
	if(UGS_queue != 0)		BS_PDU_Generator(PT_UGS, UGS_BW, BCID);
	if(ertPS_queue != 0)	BS_PDU_Generator(PT_ertPS, ertPS_BW, BCID);
	if(rtPS_queue != 0)		BS_PDU_Generator(PT_rtPS, rtPS_BW, BCID);	
	if(nrtPS_queue != 0)	BS_PDU_Generator(PT_nrtPS, nrtPS_BW, BCID);
	if(BE_queue != 0)		BS_PDU_Generator(PT_BE, BE_BW, BCID);	
	BS_PDU_transmit(BCID, Symbol_number*symbolSize_, Symbol_number/DL_subchannelNum_);
}

void 
Mac802_16::SS_Scheduler(int BCID, int Symbol_number)
{
	BCID_List *BCID_tmp = Search_BCID(BCID);
	SFID_List *SFID_tmp = NULL;
	int All_UGS_BW = -1, All_ertPS_BW = -1, All_rtPS_BW = -1, All_nrtPS_BW = -1, All_BE_BW = -1;
	int symbolSize_ = 0, BW = 0, UGS_BW = 0, ertPS_BW = 0, rtPS_BW = 0, nrtPS_BW = 0, BE_BW = 0;
	int UGS_queue = ss_buf->lookup(Search_BCID(BCID)->srcIP)->UGS.byteLength();
	int ertPS_queue = ss_buf->lookup(Search_BCID(BCID)->srcIP)->ertPS.byteLength();
	int rtPS_queue = ss_buf->lookup(Search_BCID(BCID)->srcIP)->rtPS.byteLength();
	int nrtPS_queue = ss_buf->lookup(Search_BCID(BCID)->srcIP)->nrtPS.byteLength();
	int BE_queue = ss_buf->lookup(Search_BCID(BCID)->srcIP)->BE.byteLength();
	int count = 0;
	double q5 = 0.30, q4 = 0.30, q3 = 0.30, q2 = 0.05, q1 = 0.05;
	
	if(BCID_tmp != NULL)
	{
		SFID_tmp = BCID_tmp->SF;
		
		while(SFID_tmp != NULL)
		{	
			if(SFID_tmp->SFID%10 == 0)
				All_UGS_BW += SFID_tmp->BW;
			else if(SFID_tmp->SFID%10 == 1)
				All_ertPS_BW += SFID_tmp->BW;
			else if(SFID_tmp->SFID%10 == 2)
				All_rtPS_BW += SFID_tmp->BW;
			else if(SFID_tmp->SFID%10 == 3)
				All_nrtPS_BW += SFID_tmp->BW;
			else if(SFID_tmp->SFID%10 == 4)
				All_BE_BW += SFID_tmp->BW;
			SFID_tmp = SFID_tmp->next;	
		}
		
		switch(BCID_tmp->MC_t)
		{
			case QPSK_12:
				symbolSize_ = 6;
				break;
			case QPSK_34:
				symbolSize_ = 9;
				break;
			case QAM16_12:
				symbolSize_ = 12;
				break;
			case QAM16_34:
				symbolSize_ = 18;
				break;
			case QAM64_23:
				symbolSize_ = 24;
				break;
			case QAM64_34:
				symbolSize_ = 27;
				break;
			default:
				break;
		}
		
		BW = symbolSize_*Symbol_number;
	}
	
	/* [QoS] Allocate uplink bandwidth to UGS traffic where it  equals  to the bandwidth at least that SS requested */
	if(All_UGS_BW != -1) 
	{
		if(UGS_queue > All_UGS_BW)
			UGS_BW = All_UGS_BW + 1;
		else
			UGS_BW = UGS_queue;
		BW -= UGS_BW;
	}
	
	/* [QoS] Allocate uplink bandwidth to ertPS traffic where it  equals  to the bandwidth at least that SS requested */
	if(All_ertPS_BW != -1) 
	{
		if(ertPS_queue > All_ertPS_BW)
			ertPS_BW = All_ertPS_BW + 1;
		else
			ertPS_BW = ertPS_queue;
		BW -= ertPS_BW;
	}
	
	/* [QoS] Allocate uplink bandwidth to rtPS traffic where it  equals  to the bandwidth at least that SS requested */
	if(All_rtPS_BW != -1) 
	{
		if(rtPS_queue > All_rtPS_BW)
			rtPS_BW = All_rtPS_BW + 1;
		else
			rtPS_BW = rtPS_queue;
		BW -= rtPS_BW;
	}
	
	/* [QoS] Allocate uplink bandwidth to nrtPS traffic where it  equals  to the bandwidth at least that SS requested */
	if(All_nrtPS_BW != -1) 
	{
		if(nrtPS_queue > All_nrtPS_BW)
			nrtPS_BW = All_nrtPS_BW + 1;
		else
			nrtPS_BW = nrtPS_queue;
		BW -= nrtPS_BW;
	}
	
	/* [QoS] Allocate uplink bandwidth to BE traffic where it  equals  to the bandwidth at least that SS requested */
	if(All_BE_BW != -1) 
	{
		if(BE_queue > All_BE_BW)
			BE_BW = All_BE_BW + 1;
		else
			BE_BW = BE_queue;
		BW -= BE_BW;
	}

	/* Allocate remainder uplink bandwidth */
	while(BW > 0 && count < 5)
	{
		/* Allocate 100*q5 bytes to UGS traffic */
		if(UGS_queue != -1 && BW != 0) 
		{
			if(BW - (int)(100*q5) < 0) 
			{
				UGS_BW += BW;
				BW = 0;
			} 
			else 
			{
				UGS_BW += (int)(100*q5);
				BW -= (int)(100*q5);
			}
		}
	
		/* Allocate 100*q4 bytes to ertPS traffic */
		if(ertPS_queue != 0 && BW != 0) 
		{
			if(BW - (int)(100*q4) < 0) 
			{
				ertPS_BW += BW;
				BW = 0;
			} 
			else 
			{
				ertPS_BW += (int)(100*q4);
				BW -= (int)(100*q4);
			}
		}
	
		/* Allocate 100*q3 bytes to rtPS traffic */
		if(rtPS_queue != 0 && BW != 0) 
		{
			if(BW - (int)(100*q3) < 0) 
			{
				rtPS_BW += BW;
				BW = 0;
			} 
			else 
			{
				rtPS_BW +=  (int)(100*q3);
				BW -= (int)(100*q3);
			}
		}
		
		/* Allocate 100*q2 bytes to nrtPS traffic */
		if(nrtPS_queue != 0 && BW != 0) 
		{
			if(BW - (int)(100*q2) < 0) 
			{
				nrtPS_BW += BW;
				BW = 0;
			} 
			else 
			{
				nrtPS_BW +=  (int)(100*q2);
				BW -= (int)(100*q2);
			}
		}
		
		/* Allocate 100*q1 bytes to BE traffic */
		if(BE_queue != 0 && BW != 0) 
		{
			if(BW - (int)(100*q1) < 0) 
			{
				BE_BW += BW;
				BW = 0;
			} 
			else 
			{
				BE_BW +=  (int)(100*q1);
				BW -= (int)(100*q1);
			}
		}
		count++;
	}

	if(UGS_queue != 0)		SS_PDU_Generator(PT_UGS, UGS_BW, BCID);
	if(ertPS_queue != 0)	SS_PDU_Generator(PT_ertPS, ertPS_BW, BCID);
	if(rtPS_queue != 0)		SS_PDU_Generator(PT_rtPS, rtPS_BW, BCID);	
	if(nrtPS_queue != 0)	SS_PDU_Generator(PT_nrtPS, nrtPS_BW, BCID);
	if(BE_queue != 0)		SS_PDU_Generator(PT_BE, BE_BW, BCID);	
	SS_PDU_transmit(BCID, Symbol_number*symbolSize_, UL_symbolNum_);
}

void 
Mac802_16::BS_PDU_Generator(packet_t ser_type, int grab_byte,int bcid)
{			
	printf("Downlink Session Start (Dealing with BCID %d): \n",bcid);
	switch(ser_type){
		case PT_UGS:
			printf("BS will grab %d bytes from UGS-Queue, and There are %d bytes in Queue\n",grab_byte,Queue_list->Search_BCID(bcid)->UGS.byteLength());
			BS_Frag_or_Pack(PT_UGS, Queue_list->Search_BCID(bcid)->UGS.count(grab_byte), bcid);
			break;
		case PT_rtPS:
			printf("BS will grab %d bytes from rtPS-Queue, and There are %d bytes in Queue \n",grab_byte,Queue_list->Search_BCID(bcid)->rtPS.byteLength());
			BS_Frag_or_Pack(PT_rtPS, Queue_list->Search_BCID(bcid)->rtPS.count(grab_byte), bcid);
			break;
		case PT_ertPS:
			printf("BS will grab %d bytes from ertPS-Queue, and There are %d bytes in Queue \n",grab_byte,Queue_list->Search_BCID(bcid)->ertPS.byteLength());
			BS_Frag_or_Pack(PT_ertPS, Queue_list->Search_BCID(bcid)->ertPS.count(grab_byte), bcid);
			break;					
		case PT_nrtPS:
			printf("BS will grab %d bytes from nrtPS-Queue, and There are %d bytes in Queue \n",grab_byte,Queue_list->Search_BCID(bcid)->nrtPS.byteLength());
			BS_Frag_or_Pack(PT_nrtPS, Queue_list->Search_BCID(bcid)->nrtPS.count(grab_byte), bcid);
			break;
		case PT_BE:
			printf("BS will grab %d bytes from BE-Queue, and There are %d bytes in Queue\n",grab_byte,Queue_list->Search_BCID(bcid)->BE.byteLength());
			BS_Frag_or_Pack(PT_BE, Queue_list->Search_BCID(bcid)->BE.count(grab_byte), bcid);
			break;
		default: 
			break;
	}	
}

void 
Mac802_16::SS_PDU_Generator(packet_t ser_type, int grab_byte,int bcid)
{						
	printf("Uplink Session Start (Dealing with BCID %d): \n",bcid);
	switch(ser_type)
	{                   
		case PT_UGS:
			printf("SS will grab %d bytes from UGS-Queue, and There are %d bytes in Queue\n",grab_byte
				,ss_buf->lookup(Search_BCID(bcid)->srcIP)->UGS.byteLength());
			SS_Frag_or_Pack(PT_UGS, ss_buf->lookup(Search_BCID(bcid)->srcIP)->UGS.count(grab_byte), bcid);
			break;
		case PT_rtPS:
			printf("SS will grab %d bytes from rtPS-Queue, and There are %d bytes in Queue\n",grab_byte
				,ss_buf->lookup(Search_BCID(bcid)->srcIP)->rtPS.byteLength());
			SS_Frag_or_Pack(PT_rtPS, ss_buf->lookup(Search_BCID(bcid)->srcIP)->rtPS.count(grab_byte), bcid);	
			break;
		case PT_ertPS:
			printf("SS will grab %d bytes from ertPS-Queue, and There are %d bytes in Queue\n",grab_byte
				,ss_buf->lookup(Search_BCID(bcid)->srcIP)->ertPS.byteLength());
			SS_Frag_or_Pack(PT_ertPS, ss_buf->lookup(Search_BCID(bcid)->srcIP)->ertPS.count(grab_byte), bcid);
			break;				
		case PT_nrtPS:
			printf("SS will grab %d bytes from nrtPS-Queue, and There are %d bytes in Queue\n",grab_byte
				,ss_buf->lookup(Search_BCID(bcid)->srcIP)->nrtPS.byteLength());
			SS_Frag_or_Pack(PT_nrtPS, ss_buf->lookup(Search_BCID(bcid)->srcIP)->nrtPS.count(grab_byte), bcid);
			break;
		case PT_BE:
			printf("SS will grab %d bytes from BE-Queue, and There are %d bytes in Queue\n",grab_byte
				,ss_buf->lookup(Search_BCID(bcid)->srcIP)->BE.byteLength());
			SS_Frag_or_Pack(PT_BE, ss_buf->lookup(Search_BCID(bcid)->srcIP)->BE.count(grab_byte), bcid);		
			break;
		default:return;	
	}	
	return;
}

void 
Mac802_16::BS_Frag_or_Pack(packet_t ser_type, int num, int user)
{  
	static int32_t tmp_size = PDUSIZE;	
	Packet* pkt_tmp;
	Packet* tmp;
	
begin:		
	while(num)
	{		
		switch(ser_type)
		{
			case PT_UGS:				
				tmp=Queue_list->Search_BCID(user)->UGS.deque();		
				break;
			case PT_rtPS:			
				tmp=Queue_list->Search_BCID(user)->rtPS.deque();	
				break;
			case PT_ertPS:				
				tmp=Queue_list->Search_BCID(user)->ertPS.deque();	
				break;
			case PT_nrtPS:			
				tmp=Queue_list->Search_BCID(user)->nrtPS.deque();	
				break;
			case PT_BE:			
				tmp=Queue_list->Search_BCID(user)->BE.deque();		
				break;
			default:	
				break;
		}
		
		struct hdr_cmn* pkt = HDR_CMN(tmp);
		//struct hdr_cmn* pkt_tmp_cmn=HDR_CMN(pkt_tmp);
	    struct hdr_mac802_16* dh = HDR_MAC802_16(tmp);		
		//struct hdr_mac802_16* pkt_tmp_dh = HDR_MAC802_16(pkt_tmp);
		
		if(pkt->size() <= tmp_size)
		{	  //need to pack
				dh->type = 0x01;							
				pack_subheader_t* psh = sub_HDR_MAC802_16_pack(tmp);
				//printf("Add packing subheader FSN:%d\n",psh->FSN);
				psh->FSN=((psh->FSN)+1)%8;				
				if(pkt->size() < tmp_size)
				{  //Add PACKing subheader; add SDU or SDU fragment					
					psh->FC=0x0;
					psh->Length = pkt->size();
					tmp_size -= pkt->size();
					//printf("Need to Pack:\n");	
					break;
				}	
				else{ //add PACKing subheader; add fragment					
					psh->FC=0x2;					
					pkt_tmp=tmp; 
					Queue_list->Search_BCID(user)->PDUQueue.enque(pkt_tmp->copy());					
					//printf("Complete a MPDU\nPacking with fragmetation; The remaining fragment is stored in queue\n");					
					tmp_size = PDUSIZE;								
				}
				num--;
				goto begin;	
		}
		else{  //Need fragmetation
        	dh->type = 0x04; 
			tmp->type_=2;				
			if(Queue_list->Search_BCID(user)->fragQueue.length()!= 0)
			{ //Fragment-queue is not empty;								
Frag_que:		pkt_tmp=Queue_list->Search_BCID(user)->fragQueue.deque();
				struct hdr_cmn* pkt = HDR_CMN(pkt_tmp);
				struct frag_subheader_t* fsh = sub_HDR_MAC802_16_frag(pkt_tmp);						
				//printf("Add fragmentation subheader FSN:%d\n",fsh->FSN);
				fsh->FSN=((fsh->FSN)+1)%8;				
				if( pkt->size()<= tmp_size)
				{ //Add SDU to payload
						//printf("Add SDU to payload\nLast Fragment\n");						
						if(pkt->size() == tmp_size)
						{
							 fsh->FC=0x1; // last fragment
							 //printf("Complete a MPDU\n\n");							 
							 tmp_size = PDUSIZE;	
							 Queue_list->Search_BCID(user)->PDUQueue.enque(pkt_tmp->copy());							 	
						}							
						else
						{
							 fsh->FC=0x3; // continue fragment  need pack
							 tmp_size-=pkt->size();							 
						}	
				}
				else
				{
					//dh->type = 0x04;
					fsh->FC=0x3;  // continue fragment					
					//printf("Continue Fragment\n");					
					int i=pkt->size();
					pkt->size()=tmp_size;					
					Queue_list->Search_BCID(user)->PDUQueue.enque(pkt_tmp->copy());
					pkt->size()=i-tmp_size;
					Queue_list->Search_BCID(user)->fragQueue.enque(pkt_tmp->copy());					
					//printf("Complete a MPDU\n The remaining fragment is stored in queue\n");					
					tmp_size = PDUSIZE;
					goto Frag_que;	
				}
			}
			else
			{   //there're no fragments in fragment-queue
				//dh->type = 0x04;
				struct frag_subheader_t* fsh = sub_HDR_MAC802_16_frag(tmp);
				struct hdr_cmn* pkt = HDR_CMN(tmp);				
				//printf("Add fragmentation subheader FSN:%d\n",fsh->FSN);
				fsh->FSN=((fsh->FSN)+1)%8;
				if(pkt->size()>tmp_size)
				{  //need to fragmentation
					int i=pkt->size();
					pkt->size()=tmp_size;	
					//printf("First Fragmentaton\n");					 					
					fsh->FC=0x2;  //first fragment
					Queue_list->Search_BCID(user)->PDUQueue.enque(tmp->copy());
					pkt->size()=i-tmp_size;
					Queue_list->Search_BCID(user)->fragQueue.enque(tmp->copy());					
					//printf("Complete a MPDU\n The remaining fragment is stored in queue\n");					
					tmp_size = PDUSIZE;					
					goto Frag_que;
				}
			}
		}
		num--;
	}

	return;
}

void 
Mac802_16::SS_Frag_or_Pack(packet_t ser_type, int num, int user)
{
	static int32_t tmp_size = PDUSIZE;	
	Packet* pkt_tmp;
    Packet* pkt_tmp_head;
	Packet* tmp;
	pkt_tmp_head=tmp;

start:	
	while(num)
	{		
		switch(ser_type)
		{
			case PT_UGS:				
					tmp=ss_buf->lookup(Search_BCID(user)->srcIP)->UGS.deque();
					break;
			case PT_rtPS:			
					tmp=ss_buf->lookup(Search_BCID(user)->srcIP)->rtPS.deque();		
					break;
			case PT_ertPS:				
					tmp=ss_buf->lookup(Search_BCID(user)->srcIP)->ertPS.deque();	
					break;
			case PT_nrtPS:			
					tmp=ss_buf->lookup(Search_BCID(user)->srcIP)->nrtPS.deque();	
					break;
			case PT_BE:			
					tmp=ss_buf->lookup(Search_BCID(user)->srcIP)->BE.deque();		
					break;
			default:											
					break;
		}
		struct hdr_cmn* pkt = HDR_CMN(tmp);
	    struct hdr_mac802_16* dh = HDR_MAC802_16(tmp);
		//struct hdr_cmn* pkt_tmp_cmn=HDR_CMN(pkt_tmp);
		//struct hdr_mac802_16* pkt_tmp_dh = HDR_MAC802_16(pkt_tmp);	
		
		if(pkt->size() <= tmp_size)
		{  //need to pack
				dh->type = 0x01;	
				tmp->type_=1;	
				struct pack_subheader_t* psh = sub_HDR_MAC802_16_pack(tmp);
				//printf("Add packing subheader FSN:%d\n",psh->FSN);
				psh->FSN=((psh->FSN)+1)%8;				
				if(pkt->size() < tmp_size)
				{  //Add PACKing subheader; add SDU or SDU fragment					
					psh->FC=0x0;
					psh->Length = pkt->size();
					tmp_size -= pkt->size();
					//printf("Need to Pack:\n");	
				}	
				else
				{ //add PACKing subheader; add fragment					
					psh->FC=0x2;
					pkt_tmp=tmp;   
					ss_buf->lookup(Search_BCID(user)->srcIP)->PDUQUEUE.enque(tmp->copy());	
					//printf("Complete a MPDU\nPacking with fragmetation; The remaining fragment is stored in queue\n");					
					tmp_size = PDUSIZE;								
				}
				num--;
				goto start;				
		}
		else
		{//Need fragmetation
        	dh->type = 0x04; 
			tmp->type_=2;		
			if(ss_buf->lookup(Search_BCID(user)->srcIP)->fragQUEUE.length()!= 0)
			{ //Fragment-queue is not empty;
SS_Frag_que:	pkt_tmp=ss_buf->lookup(Search_BCID(user)->srcIP)->fragQUEUE.deque();
				struct hdr_cmn* pkt = HDR_CMN(pkt_tmp);
				struct frag_subheader_t* fsh = sub_HDR_MAC802_16_frag(pkt_tmp);				
				//printf("Add fragmentation subheader FSN:%d\n",fsh->FSN);
				fsh->FSN=((fsh->FSN)+1)%8;				
				if( pkt->size()<= tmp_size)
				{ //Add SDU to payload
						//printf("Add SDU to payload\nLast Fragment\n");						
						if(pkt->size() == tmp_size)
						{
							 fsh->FC=0x1; // last fragment
							// printf("Complete a MPDU\n\n");							 
							 tmp_size = PDUSIZE;	
							 ss_buf->lookup(Search_BCID(user)->srcIP)->PDUQUEUE.enque(pkt_tmp->copy());																		
						}							
						else
						{
							 fsh->FC=0x1; // last fragment  need pack	
							 tmp_size-=pkt->size();														 
						}	
				}
				else
				{
					//dh->type = 0x04;
					fsh->FC=0x3;  // continue fragment					
					//printf("Continue Fragment\n");					
					int i=pkt->size();
					pkt->size()=tmp_size;					
					ss_buf->lookup(Search_BCID(user)->srcIP)->PDUQUEUE.enque(pkt_tmp->copy());
					pkt->size()=i-tmp_size;
					ss_buf->lookup(Search_BCID(user)->srcIP)->fragQUEUE.enque(pkt_tmp->copy());
					//printf("Complete a MPDU\n The remaining fragment is stored in queue\n");					
					tmp_size = PDUSIZE;
					goto SS_Frag_que;	
				}
			}
			else
			{   //there're no fragments in fragment-queue
				//dh->type = 0x04;
				struct frag_subheader_t* fsh = sub_HDR_MAC802_16_frag(tmp);
				struct hdr_cmn* pkt = HDR_CMN(tmp);
				//printf("Add fragmentation subheader FSN:%d\n",fsh->FSN);
				fsh->FSN=((fsh->FSN)+1)%8;
				if(pkt->size()>tmp_size){  //need to fragmentation
					int i=pkt->size();
					pkt->size()=tmp_size;	
					//printf("First Fragmentaton\n");					 					
					fsh->FC=0x2;  //first fragment
					ss_buf->lookup(Search_BCID(user)->srcIP)->PDUQUEUE.enque(tmp->copy());
					pkt->size()=i-tmp_size;
					ss_buf->lookup(Search_BCID(user)->srcIP)->fragQUEUE.enque(tmp->copy());
					//printf("Complete a MPDU\n The remaining fragment is stored in queue\n");					
					tmp_size = PDUSIZE;					
					goto SS_Frag_que;
				}
			}
		}
		num--;
	}

	return;
}

void 
Mac802_16::BS_PDU_transmit(int user, int bw, int Symbol_number)
{
	int pkt_count;
	double interval;
	pkt_count = Queue_list->Search_BCID(user)->PDUQueue.length();
	if(pkt_count==0) return;
	interval=Symbol_number*symbolTime_/pkt_count;
	printf(">> $$$$$$$$$$ BS interval %f $$$$$$$$$$ count %d $$$$$$$$$$ %f\n", interval, pkt_count, Scheduler::instance().clock());
	printf("BS_PDU %d %d\n",Queue_list->Search_BCID(user)->PDUQueue.byteLength(),Queue_list->Search_BCID(user)->PDUQueue.length());
	if(PDU_lock == 0)
	{
		PDU_lock = 1;
		resumeBSBurst.start(interval,user,pkt_count);
	}
	return;
}

void 
Mac802_16::SS_PDU_transmit(int user, int bw, int Symbol_number)
{
	int pkt_count;
	double interval;
	pkt_count =ss_buf->lookup(Search_BCID(user)->srcIP)->PDUQUEUE.length();
	if(pkt_count==0) return;
	interval=Symbol_number*symbolTime_/pkt_count;
	//printf(">> $$$$$$$$$$ BCID %d interval %f $$$$$$$$$$ count %d $$$$$$$$$$ %f\n", user, interval, pkt_count, Scheduler::instance().clock());
	//printf("SS_PDU %d %d\n",ss_buf->lookup(Search_BCID(user)->srcIP)->PDUQUEUE.byteLength(),ss_buf->lookup(Search_BCID(user)->srcIP)->PDUQUEUE.length());
	if(PDU_lock == 0)
	{
		PDU_lock = 1;
		resumeSSBurst.start(interval,user,pkt_count);
	}
	return;
}

Packet* 
Mac802_16::Add_Mac_Header(Packet* p,int CID,packet_t ptype)
{
	struct hdr_cmn* ch=HDR_CMN(p);
	struct hdr_mac802_16* mac_16 =HDR_MAC802_16(p);

	ch->uid()   = 0;
	ch->ptype() = ptype;
	ch->iface() = -2;
	ch->error() = 0;	
	ch->size()  = 24+PDUSIZE;	
	mac_16->HT 	= 0;
	mac_16->EC 	= 0;
	mac_16->CI	= 0; 	
	mac_16->LEN	= 24+PDUSIZE;
	mac_16->CID	= CID;
	(p->type_==1) ? mac_16->type=1 : mac_16->type=2;	
	return p;	
}

void 
Mac802_16::ResumeBS16timerHandler(int user, int pkt_count, double interval)
{
	int TCID = 0;
	SFID_List* SFID_tmp = NULL;
	pkt_count--;
	printf("$$$$$$$$$$ BS interval %f $$$$$$$$$$ count %d $$$$$$$$$$ %f\n", interval, pkt_count,Scheduler::instance().clock());
	if(/*Queue_list->Search_BCID(user)->PDUQueue.length()==0*/pkt_count==0)
	{ 
		printf("########## BS ########## %d ##########%f\n ",Queue_list->Search_BCID(user)->PDUQueue.length(),Scheduler::instance().clock());
		resumeBSBurst.stop();
		PDU_lock=0;
		return;
	}
	else
	{
		//printf("BS ɶ%f   ʥ]%d\n",Scheduler::instance().clock(),Queue_list->Search_BCID(user)->PDUQueue.length());
		Packet* in=Queue_list->Search_BCID(user)->PDUQueue.deque();	
		struct hdr_cmn* ch=HDR_CMN(in);
		struct hdr_rtp* rh = hdr_rtp::access(in);
		
		//Jessy
		int typenum;
		switch(ch->ptype())
		{
			case PT_UGS:
				typenum = 5;
				break;
			case PT_ertPS:
				typenum = 6;
				break;
			case PT_rtPS:
				typenum = 7;
				break;
			case PT_nrtPS:
				typenum = 8;
				break;
			case PT_BE:
				typenum = 9;
				break;
			default:
				break;
		}
		
		SFID_tmp = Search_BCID(user)->SF;
		while(SFID_tmp!= NULL)
		{
			if(SFID_tmp->SFID%10 == typenum)
			 TCID = SFID_tmp->TCID;
			SFID_tmp = SFID_tmp->next;
		}
		//Jessy END
		
		pktBSBurst_=Add_Mac_Header(in,TCID,ch->ptype());	//Jessy	
		downtarget_->recv(pktBSBurst_->copy(),this);	
		resumeBSBurst.start(interval,user,pkt_count);
	}
}

void 
Mac802_16::ResumeSS16timerHandler(int user, int pkt_count, double interval)
{
	int TCID = 0;
	SFID_List* SFID_tmp = NULL;
	pkt_count--;
	//printf("$$$$$$$$$$ BCID %d interval %f $$$$$$$$$$ count %d $$$$$$$$$$\n",user, interval, pkt_count);
	if(/*ss_buf->lookup(Search_BCID(user)->srcIP)->PDUQUEUE.length() == 0*/pkt_count==0)
	{
		//printf("########## BCID %d ########## %d ##########\n ",user,ss_buf->lookup(Search_BCID(user)->srcIP)->PDUQUEUE.length());
		resumeSSBurst.stop();
		PDU_lock=0;	
		return;
	}
	else
	{ 
		//printf("SS %d ɶ%f   ʥ]%d\n",user,Scheduler::instance().clock(),ss_buf->lookup(Search_BCID(user)->srcIP)->PDUQUEUE.length());
		Packet* in=ss_buf->lookup(Search_BCID(user)->srcIP)->PDUQUEUE.deque();	
		struct hdr_cmn* mac_=HDR_CMN(in);
		
		//Jessy
		int typenum;
		switch(mac_->ptype())
		{
			case PT_UGS:
				typenum = 0;
				break;
			case PT_ertPS:
				typenum = 1;
				break;
			case PT_rtPS:
				typenum = 2;
				break;
			case PT_nrtPS:
				typenum = 3;
				break;
			case PT_BE:
				typenum = 4;
				break;
			default:
				break;
		}
		
		SFID_tmp = Search_BCID(user)->SF;
		while(SFID_tmp!= NULL)
		{
			if(SFID_tmp->SFID%10 == typenum)
			 TCID = SFID_tmp->TCID;
			SFID_tmp = SFID_tmp->next;
		}
		//Jessy END
		
		pktBurst_=Add_Mac_Header(in,TCID,mac_->ptype());		
		downtarget_->recv(pktBurst_->copy(),this);	
		resumeSSBurst.start(interval,user,pkt_count);
	}
}

void 
Mac802_16::transmit(Packet* p, double timeout)
{	
	mhDefer_.start(timeout);
}


int cnt=0;
void 
Mac802_16::FrameHandler()
{
	if(creatid==0)
	{
		if(cnt%200==0)
		{
			sendUCD();	
			SendDCD_.start(0);
			sendDCD();			
			SendUCD_.start(0);
		}	
	}	
	cnt++;
	
	DL_MAP_IE *DL_MAP_IE_tmp = NULL, *DL_MAP_IE_backup = NULL;
	UL_MAP_IE *UL_MAP_IE_tmp = NULL, *UL_MAP_IE_backup = NULL;
	
	DL_MAP_IE_tmp = DL_MAP_IE_head;
	
	while(DL_MAP_IE_tmp!=NULL)
	{
		DL_MAP_IE_backup = DL_MAP_IE_tmp->next;
		delete DL_MAP_IE_tmp;
		DL_MAP_IE_tmp = DL_MAP_IE_backup;
	}
	
	DL_MAP_IE_head = NULL;
	DL_MAP_IE_tail = NULL;	
	
	UL_MAP_IE_tmp = UL_MAP_IE_head;
	
	while(UL_MAP_IE_tmp!=NULL)
	{
		UL_MAP_IE_backup = UL_MAP_IE_tmp->next;
		delete UL_MAP_IE_tmp;
		UL_MAP_IE_tmp = UL_MAP_IE_backup;
	}
	
	UL_MAP_IE_head = NULL;
	UL_MAP_IE_tail = NULL;
	
	PreambleTimer.start(symbolTime_);
	FrameTimer.stop();
	FrameTimer.start(frameLength_);
}

void 
Mac802_16::PreambleHandler()
{	
	Bandwidth_Management();
	PreambleTimer.stop();
}

void 
Mac802_16::TX16timerHandler()
{
	state_=MAC_IDLE;
	mhSend_.stop();
}

void 
Mac802_16::Defer16TimerHandler()
{
	state_=MAC_SEND;		
	if(pktRNGRSP_!=0)
	{ 
		downtarget_->recv(pktRNGRSP_,this); 
		pktRNGRSP_=0; 
	}			
	state_=MAC_IDLE;	
	return;
}

void 
Mac802_16::RX16timerHandler()
{
	rx_state_=MAC_IDLE;
	mhRecv_.stop();
}

void 
Mac802_16::SendULmapHandler()
{	
	state_=MAC_SEND;
	assert(creatid==0);
	if(pktULMAP_!=0)
	{  
		downtarget_->recv(pktULMAP_,this);  
		pktULMAP_=0;
	}
	return;
}

void 
Mac802_16::SendDLmapHandler()
{	
	state_=MAC_SEND;
	assert(creatid==0);
	if(pktDLMAP_!=0)
	{  
		downtarget_->recv(pktDLMAP_,this);  
		pktDLMAP_=0;
	}
	return;
}

void 
Mac802_16::ULmapHandler(int BCID, int Symbol_number)
{	
	SS_Scheduler(BCID,Symbol_number);	
}

void 
Mac802_16::SendDCDHandler()
{
	
	state_=MAC_SEND;			
	if(pktDCD_!=0)
	{ 
		downtarget_->recv(pktDCD_,this); 
		
		pktDCD_=0; 
	}			
	state_=MAC_IDLE;	
	return;
}

void 
Mac802_16::SendUCDHandler()
{
	
	state_=MAC_SEND;
	if(pktUCD_!=0)
	{ 
		downtarget_->recv(pktUCD_,this); 
		
		pktUCD_=0; 
	}			
	state_=MAC_IDLE;
	return;
}

void 
Mac802_16::checkBackoffTimer()
{
	if(State_==MIDLE && BFt.paused())
		BFt.resume(0.0000001);
	if(State_==MSEND && BFt.busy() && ! BFt.paused())
		BFt.pause(symbolTime_);
}

void 
Mac802_16::BFhandler()
{
	if(State_==MSEND)
	{
		inc_cw();
		BFt.start(cw_,State_,symbolTime_);
		return;
	}
	
	checkBackoffTimer();
	if(pktRNGREQ_!=0)
	{ 
		State_=MSEND;
		downtarget_->recv(pktRNGREQ_,this); 
		pktRNGREQ_=0;
	}
	State_=MIDLE;
	return;	
}

void 
Mac802_16::BWhandler()
{
	if(State_==MSEND){
		inc_cw_bw();
		SendBW.start(cw_bw,State_,symbolTime_);
		return;
	}	
	checkBackoffTimer();
	if(pktBr_!=0){	
		State_=MSEND;
		downtarget_->recv(pktBr_,this); 	   
		pktBr_=0;
	}
	State_=MIDLE;
	return;	
}

double 
Mac802_16::txtime(Packet *p)
{
	struct hdr_cmn *ch = HDR_CMN(p);
	double t = ch->txtime();
	if (t < 0.0) 
	{
		drop(p, "XXX");
 		exit(1);
	}
	return t;
}

Queue_construct* 
Mac802_16::Search_Queue(int destIP)
{
	Queue_List* tmp=new Queue_List;
	return tmp->lookup(destIP);
}

BCID_List* 
Mac802_16::Search_BCID(int bcid)
{ 
	BCID_List* BCID_tmp = BCID_head;
	if(BCID_tmp != NULL)
	{
		do
		{ 
			if(BCID_tmp->BCID == bcid)
			{
				return BCID_tmp;    
			}
			else if(BCID_tmp->BCID != bcid)
			{
				BCID_tmp = BCID_tmp->next; 
			}   
		}while(BCID_tmp != NULL);
	}
    return NULL; 
}

int 
Mac802_16::Insert_BCID(int srcIP)
{
	BCID_List* BCID_tmp=new BCID_List;
	BCID_tmp->BCID = ++BCID_count;
	BCID_tmp->srcIP = srcIP;
	if(BCID_head == NULL)
	{
		BCID_head = BCID_tail = BCID_tmp;
	}
	else
	{
		BCID_tail->next=BCID_tmp;
		BCID_tail=BCID_tmp;	
	}
	return BCID_tmp->BCID;
}

BCID_List* 
Mac802_16::Search_BCID_macSA(int srcIP)
{
	BCID_List* BCID_tmp = BCID_head;
	if(BCID_tmp != NULL)
	{
		do
		{ 
			if(BCID_tmp->srcIP == srcIP)
			{
				return BCID_tmp;    
			}
			else if(BCID_tmp->srcIP != srcIP)
			{
				BCID_tmp = BCID_tmp->next; 
			}   
		}while(BCID_tmp != NULL);
	}
    return NULL; 
}

SFID_List* 
Mac802_16::Search_SFID(int SFID)
{
	BCID_List* BCID_tmp = BCID_head;
	SFID_List* SFID_tmp = BCID_tmp->SF;
	if(BCID_tmp != NULL)
	{
		do
		{		
			if(SFID_tmp != NULL)
			{
				do
				{
					if(SFID_tmp->SFID == SFID)
					{
						return SFID_tmp;    
					}
					else if(SFID_tmp->SFID != SFID)
					{				
						SFID_tmp = SFID_tmp->next;
					}   
				}while(SFID_tmp != NULL);
			}
			BCID_tmp = BCID_tmp->next;
			SFID_tmp = BCID_tmp->SF;
		}while(BCID_tmp != NULL);      
	}
	
	return NULL; 
}

SFID_List* 
Mac802_16::Search_TCID(int TCID) //Jessy
{
	BCID_List* BCID_tmp = BCID_head;
	SFID_List* TCID_tmp = BCID_tmp->SF;
	if(BCID_tmp != NULL)
	{
		do
		{		
			if(TCID_tmp != NULL)
			{
				do
				{
					if(TCID_tmp->TCID == TCID)
					{
						return TCID_tmp;    
					}
					else if(TCID_tmp->TCID != TCID)
					{				
						TCID_tmp = TCID_tmp->next;
					}   
				}while(TCID_tmp != NULL);
			}
			BCID_tmp = BCID_tmp->next;
			TCID_tmp = BCID_tmp->SF;
		}while(BCID_tmp != NULL);      
	}
	
	return NULL; 
}

int 
Mac802_16::Insert_SFID(int BCID,packet_t ptype,dir_t direction_)
{
	BCID_List* BCID_tmp = Search_BCID(BCID);
	SFID_List* SFID_tmp = new SFID_List; 
	
	if(direction_==UL)
	{
		switch(ptype)
		{		
			case PT_UGS:
				SFID_tmp->SFID = (++SFID_count1)*10;		
				printf("intsert UL UGS SFID %d\n",SFID_tmp->SFID);
				break;
			case PT_ertPS:
				SFID_tmp->SFID = (++SFID_count2)*10 + 1;	
				printf("intsert UL ertPS SFID %d\n",SFID_tmp->SFID);
				break;
			case PT_rtPS:
				SFID_tmp->SFID = (++SFID_count3)*10 + 2;	
				printf("intsert UL rtPS SFID %d\n",SFID_tmp->SFID);
				break;
			case PT_nrtPS:
				SFID_tmp->SFID = (++SFID_count4)*10 + 3;	
				printf("intsert  UL nrtPS SFID %d\n",SFID_tmp->SFID);
				break;
			case PT_BE:
				SFID_tmp->SFID = (++SFID_count5)*10 + 4;	
				printf("intsert  UL BE SFID %d\n",SFID_tmp->SFID);
				break;						
			default:
				printf("!!!Insert SFID UL error!!!");
				break;
		}
	}
	
	if(direction_==DL)
	{
		switch(ptype)
		{		
			case PT_UGS:
				SFID_tmp->SFID = (++SFID_count5)*10 + 5;	
				printf("intsert DL UGS SFID %d\n",SFID_tmp->SFID);
				break;
			case PT_ertPS:
				SFID_tmp->SFID = (++SFID_count6)*10 + 6;	
				printf("intsert DL ertPS SFID %d\n",SFID_tmp->SFID);
				break;
			case PT_rtPS:
				SFID_tmp->SFID = (++SFID_count7)*10 + 7;	
				printf("intsert DL rtPS  SFID %d\n",SFID_tmp->SFID);
				break;
			case PT_nrtPS:
				SFID_tmp->SFID = (++SFID_count8)*10 + 8;	
				printf("intsert DL nrtPS SFID %d\n",SFID_tmp->SFID);
				break;
			case PT_BE:
				SFID_tmp->SFID = (++SFID_count9)*10 + 9;	
				printf("intsert DL BE SFID %d\n",SFID_tmp->SFID);
				break;						
			default:
				printf("!!!Insert SFID UL error!!!");
				break;
		}
	}
	
	if(BCID_tmp->SF == NULL)
	{
		BCID_tmp->SF = SFID_tmp;
		BCID_tmp->SF_tail = SFID_tmp;
	}
	else
	{
		BCID_tmp->SF_tail->next = SFID_tmp;
		BCID_tmp->SF_tail = SFID_tmp;
	}
	//Jessy
	SFID_tmp->TCID = SFID_tmp->SFID;
	SFID_tmp->BCID = BCID;
	//Jessy END
	return SFID_tmp->SFID;
} 

int 
Mac802_16::command(int argc, const char*const* argv)
{
	if (argc == 3) 
	{
		if (strcmp(argv[1], "log-target") == 0) 
		{ 
			logtarget_ = (NsObject*) TclObject::lookup(argv[2]);
			if(logtarget_ == 0)
				return TCL_ERROR;
		}
	} 
	return Mac::command(argc, argv);
}

static class Mac802_16Class : public TclClass
{
public:
	Mac802_16Class() : TclClass("Mac/802_16") {}
	TclObject* create(int, const char*const*) 
	{
		return (new Mac802_16());
	}
} class_mac802_16;
