/**************************************************************************************
* *Copyright (c) 2006 Regents of the University of Chang Gung 						*
* *All rights reserved.													*
 *																*
 * Redistribution and use in source and binary forms, with or without						*
 * modification, are permitted provided that the following conditions					*
 * are met: 															*
 * 1. Redistributions of source code must retain the above copyright						*
 *    notice, this list of conditions and the following disclaimer.						*
 * 2. Redistributions in binary form must reproduce the above copyright					*
 *    notice, this list of conditions and the following disclaimer in the						*
 *    documentation and/or other materials provided with the distribution.					*
 * 3. All advertising materials mentioning features or use of this software					*
 *    must display the following acknowledgement:									*
 *	This product includes software developed by the Computer Systems					*
 *	Engineering Group at Lawrence Berkeley Laboratory.							*
 * 4. Neither the name of the University nor of the Laboratory may be used					*
 *    to endorse or promote products derived from this software without					*
 *    specific prior written permission.										*
 *5. If you have any problem about these codes, 									*
       please mail to antibanish@gmail.com or b9229008@stmail.cgu.edu.tw                    			*
**************************************************************************************/
#include "packet-802_16.h"

int hdr_mac802_16::offset_;

int rng_rsp_t::offset_;
int rng_req_t::offset_; 
int bw_req_t::offset_;
int UL_MAP::offset_;
int DL_MAP::offset_;
int pack_subheader_t::offset_;
int frag_subheader_t::offset_;
int DCD::offset_;
int UCD::offset_;

static class packet_16_header_class :public PacketHeaderClass {

	public:
		packet_16_header_class() : PacketHeaderClass("PacketHeader/Packet_16", sizeof(hdr_mac802_16))		{
			bind_offset(&hdr_mac802_16::offset_);
		}

} class_packet_16 ;

static class packet_16_DLMAP :public PacketHeaderClass {

	public:
		packet_16_DLMAP() : PacketHeaderClass("PacketHeader/Packet_16", sizeof(DL_MAP))		{
			bind_offset(&DL_MAP::offset_);
		}

} class_packet_16_DL_MAP ;

static class packet_16_ULMAP :public PacketHeaderClass {

	public:
		packet_16_ULMAP() : PacketHeaderClass("PacketHeader/Packet_16", sizeof(UL_MAP))		{
			bind_offset(&UL_MAP::offset_);
		}

} class_packet_16_UL_MAP ;

static class packet_16_rngrsp_class :public PacketHeaderClass {

	public:
		packet_16_rngrsp_class() : PacketHeaderClass("PacketHeader/Packet_16", sizeof(rng_rsp_t))		{
			bind_offset(&rng_rsp_t::offset_);
		}

} class_packet_rngrsp_16 ; 

static class packet_16_rngreq_class :public PacketHeaderClass {

	public:
		packet_16_rngreq_class() : PacketHeaderClass("PacketHeader/Packet_16", sizeof(rng_req_t))		{
			bind_offset(&rng_req_t::offset_);
		}

} class_packet_rngreq_16 ;


static class packet_16_bwreq_class :public PacketHeaderClass {

	public:
		packet_16_bwreq_class() : PacketHeaderClass("PacketHeader/Packet_16", sizeof(bw_req_t))		{
			bind_offset(&bw_req_t::offset_);
		}

} class_packet_16_bwreq ;

static class packet_16_header_pack :public PacketHeaderClass {

	public:
		packet_16_header_pack() : PacketHeaderClass("PacketHeader/Packet_16", sizeof(pack_subheader_t))		{
			bind_offset(&pack_subheader_t::offset_);
		}

} class_packet_16_pack ;

static class packet_16_header_frag :public PacketHeaderClass {

	public:
		packet_16_header_frag() : PacketHeaderClass("PacketHeader/Packet_16", sizeof(frag_subheader_t))		{
			bind_offset(&frag_subheader_t::offset_);
		}

} class_packet_16_frag ;

static class packet_16_header_DCD :public PacketHeaderClass {

	public:
		packet_16_header_DCD() : PacketHeaderClass("PacketHeader/Packet_16", sizeof(DCD))		{
			bind_offset(&DCD::offset_);
		}

} class_packet_16_DCD ;

static class packet_16_header_UCD :public PacketHeaderClass {

	public:
		packet_16_header_UCD() : PacketHeaderClass("PacketHeader/Packet_16", sizeof(UCD))		{
			bind_offset(&UCD::offset_);
		}

} class_packet_16_UCD ;
