/**************************************************************************************
* *Copyright (c) 2006 Regents of the University of Chang Gung 						*
* *All rights reserved.													*
 *																*
 * Redistribution and use in source and binary forms, with or without						*
 * modification, are permitted provided that the following conditions					*
 * are met: 															*
 * 1. Redistributions of source code must retain the above copyright						*
 *    notice, this list of conditions and the following disclaimer.						*
 * 2. Redistributions in binary form must reproduce the above copyright					*
 *    notice, this list of conditions and the following disclaimer in the						*
 *    documentation and/or other materials provided with the distribution.					*
 * 3. All advertising materials mentioning features or use of this software					*
 *    must display the following acknowledgement:									*
 *	This product includes software developed by the Computer Systems					*
 *	Engineering Group at Lawrence Berkeley Laboratory.							*
 * 4. Neither the name of the University nor of the Laboratory may be used					*
 *    to endorse or promote products derived from this software without					*
 *    specific prior written permission.										*
 *5. If you have any problem about these codes, 									*
       please mail to antibanish@gmail.com or b9229008@stmail.cgu.edu.tw                    			*
**************************************************************************************/
#ifndef ns_packet_80216_h
#define ns_packet_80216_h
#include "packet.h"
#include "mac-802_16.h"

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	void *VALUE;	
	
}TLV_BASIC_V;

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[1];
	
}TLV_BASIC_1;

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[2];
	
}TLV_BASIC_2;

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[3];
	
}TLV_BASIC_3;

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[4];
	
}TLV_BASIC_4;

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[5];
	
}TLV_BASIC_5;

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[6];
	
}TLV_BASIC_6;

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[8];
	
}TLV_BASIC_8;

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[9];
	
}TLV_BASIC_9;

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[13];
	
}TLV_BASIC_13;

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[16];
	
}TLV_BASIC_16;

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[20];
	
}TLV_BASIC_20;

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[21];
	
}TLV_BASIC_21;

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[128];
	
}TLV_BASIC_128;


/* 11.13.19.3.4.3 Protocol */
#define Protocol_Numbers 3

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[Protocol_Numbers];
	
}TLV_BASIC_Protocol_N;

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[3*Protocol_Numbers];
	
}TLV_BASIC_Protocol_3N;

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[4*Protocol_Numbers];
	
}TLV_BASIC_Protocol_4N;

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[8*Protocol_Numbers];
	
}TLV_BASIC_Protocol_8N;

typedef struct{
	u_int16_t FLAG;	
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[12*Protocol_Numbers];
	
}TLV_BASIC_Protocol_12N;

typedef struct{
	u_int16_t FLAG;
	u_int8_t TYPE;
	u_int8_t LENGTH;
	u_int8_t VALUE[32*Protocol_Numbers];
	
}TLV_BASIC_Protocol_32N;


//test
	
/*******************************************************************************

		 TLV Data Base - Common Encoding

		(11.1 Common encodings)

********************************************************************************/

/* 11.13.19.3.3 Classifier error parameter set pp.708*/
typedef struct{
//	u_int16_t FLAG;
	u_int8_t LENGTH;

	TLV_BASIC_2	TYPE_1_Errored_parameter;  // Notice  11.13.19.3.3.1 Errored parameter 
	TLV_BASIC_1 	TYPE_2_Error_code;
	TLV_BASIC_V	TYPE_3_Error_message;

}TLV_SPEC_CST_SUB_2;


/* Using IPv4 or IPv6 address	*/
typedef struct{
	TLV_BASIC_Protocol_8N 	IPv4;
	TLV_BASIC_Protocol_32N 	IPv6;

}TLV_SPEC_CST_SUB_3_IP;


/* 11.13.19.3.4 Packet classification rule pp.709*/
typedef struct{
//	u_int16_t FLAG;
	u_int8_t LENGTH;

	TLV_BASIC_1 			TYPE_1_Classifier_rule_priority;
	TLV_BASIC_3 			TYPE_2_IP_Type_of_DSCP_range_and_mask;
	TLV_BASIC_Protocol_N		TYPE_3_Protocol;
	TLV_SPEC_CST_SUB_3_IP 		TYPE_4_IP_masked_source_address;
	TLV_SPEC_CST_SUB_3_IP 		TYPE_5_IP_destination_address;
	TLV_BASIC_Protocol_4N 		TYPE_6_Protocol_source_port_range;
	TLV_BASIC_Protocol_4N 		TYPE_7_Protocol_destination_port_range;
	TLV_BASIC_Protocol_12N 		TYPE_8_IEEE_802_3_Ethernet_destination_MAC_address;
	TLV_BASIC_Protocol_12N 		TYPE_9_IEEE_802_3_Ethernet_source_MAC_address;
	TLV_BASIC_3 			TYPE_10_Ethertype_IEEE_802_2_SAP;
	TLV_BASIC_2			TYPE_11_IEEE_802_1D_User_Priority;
	TLV_BASIC_2 			TYPE_12_IEEE_802_1Q_VLAN_ID;
	TLV_BASIC_1 			TYPE_13_Associated_PHSI;
	TLV_BASIC_2 			TYPE_14_Packet_Classifier_Rule_Index;
	TLV_BASIC_Protocol_3N 		TYPE_15_IPv6_Flow_label;   // USE in CST = 101 / 105 / 107
	TLV_BASIC_V 					*TYPE_143_Vendor_specific_classifier_parameters; 
								// TLVDB_COMMON_ENCODING -> TYPE_143_Vendor_specific_information
	
}TLV_SPEC_CST_SUB_3;


/* 11.13.19.3.6 PHS error parameter set pp.714*/
typedef struct{
//	u_int16_t FLAG;
	u_int8_t LENGTH;

	TLV_BASIC_1 	TYPE_1_Errored_parameter;
	TLV_BASIC_1 	TYPE_2_Error_code;
	TLV_BASIC_V	TYPE_3_Error_message;
	
}TLV_SPEC_CST_SUB_5;


/* 11.13.19.3.7 PHS Rule pp.715*/
typedef struct{
//	u_int16_t FLAG;
	u_int8_t LENGTH;

	TLV_BASIC_1 	TYPE_1_PHSI;
	TLV_BASIC_V	TYPE_2_PHSF;
//	preparing		TYPE_3_PHSM;
	TLV_BASIC_1 TYPE_4_PHSS;
	TLV_BASIC_1 TYPE_5_PHSV;
	TLV_BASIC_V *TYPE_143_Vendor_specific_PHS_parameters;// TLVDB_COMMON_ENCODING -> TYPE_143_Vendor_specific_information 

}TLV_SPEC_CST_SUB_6;

/* 11.13.19.4.2 ATM Classifier TLV pp.718*/
typedef struct{
//	u_int16_t FLAG;
	u_int8_t LENGTH;	

	TLV_BASIC_2 TYPE_1_VPI_classifier;
	TLV_BASIC_2 TYPE_2_VCI_classification;
	TLV_BASIC_16 TYPE_3_ATM_Classifier_ID;

}TLV_SPEC_CST_ATM_SUB_2;


/* 11.13.19.4 ATM CS Encodings for Configuration and MAC Messaging pp.718*/
typedef struct{
	TLV_BASIC_1  			TYPE_1_ATM_switching_encoding;
	TLV_SPEC_CST_ATM_SUB_2 	TYPE_2_ATM_Classifier_TLV;
	TLV_BASIC_1 			TYPE_3_ATM_Classifier_DSC_Action;			//pp.719
	TLV_SPEC_CST_SUB_2 		TYPE_4_ATM_Classifier_Error_Parameter_Set; 	//pp.720

}TLV_SPEC_CST_ATM;

/* 11.13.19.3 Packet CS encodings for configuration and MAC messaging pp.707*/
typedef struct{
	TLV_BASIC_1 			TYPE_1_Classifier_DSC_action;			//pp.707
	TLV_SPEC_CST_SUB_2 		TYPE_2_Classifier_error_parameter_set;	//pp.708
	TLV_SPEC_CST_SUB_3 		TYPE_3_Packet_classification_rule;		//pp.709
	TLV_BASIC_1 			TYPE_4_PHS_DSC_action;					//pp.714
	TLV_SPEC_CST_SUB_5 		TYPE_5_PHS_error_parameter_set;			//pp.714
	TLV_SPEC_CST_SUB_6 		TYPE_6_PHS_Rule;						//pp.715
	
}TLV_SPEC_CST_ENCODING;


/* 11.13 Service Flow management encodings */
typedef struct{
//	u_int16_t FLAG;
	u_int8_t LENGTH;

	TLV_BASIC_4 TYPE_1_Service_Flow_Identifier;
	TLV_BASIC_2 TYPE_2_CID;
	TLV_BASIC_128 TYPE_3_Service_Class_Name;
//	preparing		TYPE_4_reserved;
	TLV_BASIC_1 TYPE_5_QoS_Parameter_Set_Type;
	TLV_BASIC_1 TYPE_6_Traffic_Priority;
	TLV_BASIC_4 TYPE_7_Maximum_Sustained_Traffic_Rate;
	TLV_BASIC_4 TYPE_8_Maximum_Traffic_Burst;
	TLV_BASIC_4 TYPE_9_Minimum_Reserved_Traffic_Rate;
	TLV_BASIC_4 TYPE_10_Minimum_Tolerable_Traffic_Rate;
	TLV_BASIC_1 TYPE_11_Service_Flow_Scheduling_Type;
	TLV_BASIC_4 TYPE_12_Request_Transmission_Policy;
	TLV_BASIC_4 TYPE_13_Tolerated_Jitter;
	TLV_BASIC_4 TYPE_14_Maximum_Latency;
	TLV_BASIC_1 TYPE_15_Fixed_length_versus_Variable_length_SDU_Indicator;
	TLV_BASIC_1 TYPE_16_SDU_Size;
	TLV_BASIC_2 TYPE_17_Target_SAID;
	TLV_BASIC_1 TYPE_18_ARQ_Enable;
	TLV_BASIC_2 TYPE_19_ARQ_WINDOW_SIZE;
	TLV_BASIC_2 TYPE_20_ARQ_RETRY_TIMEOUT_Transmitter_Delay;
	TLV_BASIC_2 TYPE_21_ARQ_RETRY_TIMEOUT_Receiver_Delay;
	TLV_BASIC_2 TYPE_22_ARQ_BLOCK_LIFETIME;
	TLV_BASIC_2 TYPE_23_ARQ_SYNC_LOSS;
	TLV_BASIC_1 TYPE_24_ARQ_DELIVER_IN_ORDER;
	TLV_BASIC_2 TYPE_25_ARQ_PURGE_TIMEOUT;
	TLV_BASIC_2 TYPE_26_ARQ_BLOCK_SIZE;
//	preparing		TYPE_27_reserved;
	TLV_BASIC_1 TYPE_28_CS_Specification;
	TLV_BASIC_V *TYPE_143_Vendor_specific_QoS_Parameter;  // TLVDB_COMMON_ENCODING -> TYPE_143_Vendor_specific_information

/* 11.13.19.2 CS parameter encoding rules */
	TLV_SPEC_CST_ATM	    TYPE_99_CS_ATM;
	TLV_SPEC_CST_ENCODING TYPE_100_CS_Packet_IPv4;
	TLV_SPEC_CST_ENCODING TYPE_101_CS_Packet_IPv6;
	TLV_SPEC_CST_ENCODING TYPE_102_CS_Packet_802_3_Ethernet;
	TLV_SPEC_CST_ENCODING TYPE_103_CS_Packet_802_1Q_VLAN;
	TLV_SPEC_CST_ENCODING TYPE_104_CS_Packet_IPV4_over_802_3_Ethernet;
	TLV_SPEC_CST_ENCODING TYPE_105_CS_Packet_IPV6_over_802_3_Ethernet;
	TLV_SPEC_CST_ENCODING TYPE_106_CS_Packet_IPV4_over_802_1Q_VLAN;
	TLV_SPEC_CST_ENCODING TYPE_107_CS_Packet_IPV6_over_802_1Q_VLAN;

}TLV_SPEC_SERVICE_FLOW;


/* 11.1 Common encodings */
struct TLVDB_COMMON_ENCODING{
	TLV_BASIC_V 		TYPE_143_Vendor_specific_information;
	TLV_BASIC_3 		TYPE_144_Vendor_ID_encoding;
	TLV_SPEC_SERVICE_FLOW *TYPE_145_Uplink_service_flow;  	//   use the same variable with TYPE_146
	TLV_SPEC_SERVICE_FLOW *TYPE_146_Downlink_service_flow; //   use the same variable with TYPE_145
	TLV_BASIC_1 		TYPE_147_Current_transmit_power;
	TLV_BASIC_1 		TYPE_148_MAC_version_encoding;
	TLV_BASIC_21 	TYPE_149_HMAC_tuple;	
											
};


/*******************************************************************************

		 TLV Data Base - Configuration File

		(11.2 Configuration file encodings)

********************************************************************************/

typedef struct{
	TLV_BASIC_4 IPv4;
	TLV_BASIC_16 IPv6;	
}TLV_SPEC_IP_VERSION;


/* 11.2.2 Software upgrade descriptors */
typedef struct{
//	u_int16_t FLAG;
	u_int8_t LENGTH;

	TLV_BASIC_V TYPE_1_Hardware_ID;
	TLV_BASIC_V TYPE_2_Software_version;
	TLV_BASIC_V TYPE_3_Upgrade_filename;
	TLV_BASIC_3 *TYPE_144_Vendor_ID; // TLVDB_COMMON_ENCODING -> TYPE_144_Vendor_ID_encoding

}TLV_SPEC_UPGRADE;


/* 11.2 Configuration file encodings */
struct TLVDB_CONFIGURATION_FILE{
 	TLV_BASIC_20 		TYPE_1_SS_MIC_configuration_setting;	
	TLV_SPEC_UPGRADE 	TYPE_2_Software_upgrade_descriptors;	
	TLV_SPEC_IP_VERSION TYPE_3_Software_upgrade_TFTP_server;
	TLV_BASIC_4 			TYPE_4_TFTP_Server_Timestamp;
	TLV_SPEC_IP_VERSION TYPE_5_Authorization_Node;
	TLV_SPEC_IP_VERSION TYPE_6_Registration_Node;
	TLV_SPEC_IP_VERSION TYPE_7_Provisioning_Node;
	
};


/*******************************************************************************

		 TLV Data Base - Management Message

********************************************************************************/

/* Table 350XUCD PHY-specific channel encodings X WirelessMAN-SC */
typedef struct{
	TLV_BASIC_2 TYPE_150_Symbol_rate;
	TLV_BASIC_1 TYPE_151_SSTG;
	TLV_BASIC_1 TYPE_152_Roll_off_factor;
	TLV_BASIC_1 TYPE_153_Power_adjustment_rule;
	TLV_BASIC_1 TYPE_154_Minislot_Size;
	TLV_BASIC_1 TYPE_155_UL_channel_ID;
	
}TLV_SPEC_UCD_PHY_SC;


/* Table 351XUCD PHY-specific channel encodings X WirelessMAN-SCa */
typedef struct{
	TLV_BASIC_2 TYPE_150_Symbol_rate;
	TLV_BASIC_1 TYPE_151_SSTG;
	TLV_BASIC_1 TYPE_152_Roll_off_factor;
	TLV_BASIC_1 TYPE_153_Power_adjustment_rule;
	TLV_BASIC_1 TYPE_154_Initial_Ranging_SSTG;
	TLV_BASIC_1 TYPE_155_Minislot_Size;
	TLV_BASIC_1 TYPE_156_UL_channel_ID;
	
}TLV_SPEC_UCD_PHY_SCa;


/* Table 352XUCD PHY-specific channel encodings X WirelessMAN-OFDM */
typedef struct{
	TLV_BASIC_1 TYPE_150_Subchannelization_REQ_Region_Full_Parameters;
	TLV_BASIC_1 TYPE_151_Subchannelization_focused_contention_codes;

}TLV_SPEC_UCD_PHY_OFDM;


/* Table 353XUCD PHY-specific channel encodings X WirelessMAN-OFDMA */
typedef struct{
	TLV_BASIC_1 TYPE_150_Initial_ranging_codes;
	TLV_BASIC_1 TYPE_151_Periodic_ranging_codes;
	TLV_BASIC_1 TYPE_152_Bandwidth_request_codes;
	TLV_BASIC_1 TYPE_153_Periodic_ranging_backoff_start;
	TLV_BASIC_1 TYPE_154_Periodic_rangingbackoff_end;
	TLV_BASIC_1 TYPE_155_Start_of_ranging_codesgroup;
	TLV_BASIC_1 TYPE_156_Permutation_base;
	TLV_BASIC_9 TYPE_157_UL_allocated_subchannels_bitmap;
	TLV_BASIC_13 TYPE_158_Optional_permutationUL_Allocated_subchannels_bitmap;
	TLV_BASIC_1 TYPE_159_Band_AMC_Allocation_Threshold;
	TLV_BASIC_1 TYPE_160_Band_AMC_Release_Threshold;
	TLV_BASIC_1 TYPE_161_Band_AMC_Allocation_Timer;
	TLV_BASIC_1 TYPE_162_Band_AMC_Release_Timer;
	TLV_BASIC_1 TYPE_163_Band_Status_Reporting_MAX_Period;
	TLV_BASIC_1 TYPE_164_Band_AMC_Retry_Timer;
	TLV_BASIC_1 TYPE_165_Safety_Channel_Allocation_Threshold;
	TLV_BASIC_1 TYPE_166_Safety_Channel_Release_Threshold;
	TLV_BASIC_1 TYPE_167_Safety_Channel_Allocation_Timer;
	TLV_BASIC_1 TYPE_168_Safety_Channel_Release_Timer;
	TLV_BASIC_1 TYPE_169_Bin_Status_Reporting_MAX_Period;
	TLV_BASIC_1 TYPE_170_Safety_Channel_Retry_Timer;
	TLV_BASIC_1 TYPE_171_H_ARQ_ACK_delay_for_UL_burst;
	TLV_BASIC_1 TYPE_172_CQICH_Band_AMCTransition_Delay;

}TLV_SPEC_UCD_PHY_OFDMA;


/* Table 354XUCD burst profile encodingsXWirelessMAN-SC */
typedef struct{
	TLV_BASIC_1 TYPE_150_Modulation_type;
	TLV_BASIC_1 TYPE_151_Preamble_length;
	TLV_BASIC_1 TYPE_152_FEC_Code_Type;
	TLV_BASIC_1 TYPE_153_RS_information_bytes;
	TLV_BASIC_1 TYPE_154_RS_parity_bytes;
	TLV_BASIC_1 TYPE_155_BCC_code_type;
	TLV_BASIC_1 TYPE_156_BTC_row_code_type;
	TLV_BASIC_1 TYPE_157_BTC_column_code_type;
	TLV_BASIC_1 TYPE_158_BTC_interleaving_type;
	TLV_BASIC_2 TYPE_159_Randomizer_seed;
	TLV_BASIC_1 TYPE_160_Last_codeword_length;

}TLV_SPEC_UCD_UBP_SC;


/* Table 355XUCD burst profile encodingsXWirelessMAN-SCa */
typedef struct{
	TLV_BASIC_1 TYPE_150_Modulation_type;
	TLV_BASIC_1 TYPE_151_Preamble_length;
	TLV_BASIC_1 TYPE_152_RS_Information_bytes;
	TLV_BASIC_1 TYPE_153_RS_Parity_bytes;
	TLV_BASIC_1 TYPE_154_Block_interleaver_depth;
	TLV_BASIC_1 TYPE_155_CC_CTC_Specific_parameters;
	TLV_BASIC_1 TYPE_156_Unique_word_length;
	TLV_BASIC_1 TYPE_157_Pilot_word_parameters;
	TLV_BASIC_1 TYPE_158_Burst_set_type;
	TLV_BASIC_2 TYPE_159_STC_Parameters;
	TLV_BASIC_1 TYPE_160_BTC_Code_selector;
	TLV_BASIC_1 TYPE_161_Spreading_Parameters;
	TLV_BASIC_1 TYPE_162_Subchannel_framing_parameters;	

}TLV_SPEC_UCD_UBP_SCa;


/* Table 356XUCD burst profile encodingsXWirelessMAN-OFDM */
typedef struct{ 
	TLV_BASIC_1 TYPE_150_FEC_Code_type_and_modulation_type;
	TLV_BASIC_1 TYPE_151_Focused_contention_power_boost;
	TLV_BASIC_1 TYPE_152_TCS_enable;

}TLV_SPEC_UCD_UBP_OFDM;
	

/* Table 357XUCD burst profile encodingsXWirelessMAN-OFDMA */
typedef struct{ 
	TLV_BASIC_1 TYPE_150_FEC_Code_type_and_modulation_type;
	TLV_BASIC_1 TYPE_151_Ranging_data_ratio;
	TLV_BASIC_1 TYPE_152_Normalized_C_N_override;

}TLV_SPEC_UCD_UBP_OFDMA;


/* 11.3 UCD management message encodings */
typedef struct{
	TLV_BASIC_V	COMMON_TYPE_1_Uplink_Burst_Profile;	
	TLV_BASIC_1	COMMON_TYPE_2_Contention_based_reservation_timeout;
	TLV_BASIC_2 COMMON_TYPE_3_Bandwidth_request_opportunity_size;
	TLV_BASIC_2 COMMON_TYPE_4_Ranging_request_opportunity_size;
	TLV_BASIC_4 COMMON_TYPE_5_Frequency;
	
	TLV_SPEC_UCD_PHY_SC 	PHYspec_TYPE_SC;
	TLV_SPEC_UCD_PHY_SCa 	PHYspec_TYPE_SCa;
	TLV_SPEC_UCD_PHY_OFDM 	PHYspec_TYPE_OFDM;
	TLV_SPEC_UCD_PHY_OFDMA PHYspec_TYPE_OFDMA;

	TLV_SPEC_UCD_UBP_SC 	UplinkBP_TYPE_SC;
	TLV_SPEC_UCD_UBP_SCa 	UplinkBP_TYPE_SCa;
	TLV_SPEC_UCD_UBP_OFDM 	UplinkBP_TYPE_OFDM;
	TLV_SPEC_UCD_UBP_OFDMA UplinkBP_TYPE_OFDMA;
	
}TLV_SPEC_UCD;


/* Table 360XDCD burst profile encodingsXWirelessMAN-SC */
typedef struct{ 
	TLV_BASIC_1	TYPE_150_Modulation_Type;
	TLV_BASIC_1	TYPE_151_FEC_Code_Type;
	TLV_BASIC_1	TYPE_152_RS_information_bytes;
	TLV_BASIC_1	TYPE_153_RS_Parity_Bytes;
	TLV_BASIC_1	TYPE_154_BCC_code_type;
	TLV_BASIC_1	TYPE_155_BTC_Row_code_type;
	TLV_BASIC_1	TYPE_156_BTC_Column_code_type;
	TLV_BASIC_1	TYPE_157_BTC_Interleaving_type;
	TLV_BASIC_1	TYPE_158_Last_codeword_length;
	TLV_BASIC_1	TYPE_159_DIUC_mandatory_exit_threshold;
	TLV_BASIC_1	TYPE_160_DIUC_minimum_entry_threshold;
	TLV_BASIC_1	TYPE_161_Preamble_presence;
	TLV_BASIC_1	TYPE_162_CID_In_DL_IE;

}TLV_SPEC_DCD_DBP_SC;


/* Table 361XDCD burst profile encodingsXWirelessMAN-SCa */
typedef struct{ 
	TLV_BASIC_1	TYPE_150_Modulation_Type;
	TLV_BASIC_1	TYPE_151_RS_information_bytes;
	TLV_BASIC_1	TYPE_152_RS_Parity_Bytes;
	TLV_BASIC_1	TYPE_153_DIUC_mandatory_exit_threshold;
	TLV_BASIC_1	TYPE_154_DIUC_minimum_entry_threshold;
	TLV_BASIC_1	TYPE_155_CC_CTC_Specific_parameters;
	TLV_BASIC_1	TYPE_156_Block_interleaver_depth;
	TLV_BASIC_1	TYPE_157_BTC_Code_selector;
	TLV_BASIC_1	TYPE_159_Spreading_Parameters;
	TLV_BASIC_1	TYPE_160_CID_In_DL_IE;

}TLV_SPEC_DCD_DBP_SCa;


/* Table 362XDCD burst profile encodingsXWirelessMAN-OFDM */
typedef struct{ 
	TLV_BASIC_1	TYPE_150_FEC_Code_type;
	TLV_BASIC_1	TYPE_151_DIUC_mandatory_exit_threshold;
	TLV_BASIC_1	TYPE_152_DIUC_minimum_entry_threshold;
	TLV_BASIC_1	TYPE_153_TCS_enable;

}TLV_SPEC_DCD_DBP_OFDM;
	

/* Table 363XDCD burst profile encodingsXWirelessMAN-OFDMA */	
typedef struct{
	TLV_BASIC_1	TYPE_150_FEC_Code_type;
	TLV_BASIC_1	TYPE_151_DIUC_mandatory_exit_threshold;
	TLV_BASIC_1	TYPE_152_DIUC_minimum_entry_threshold;
	
}TLV_SPEC_DCD_DBP_OFDMA;


/* 11.4 DCD management message encodings */
typedef struct{
	TLV_BASIC_V CHANNEL_TYPE_1_Downlink_Burst_Profile;
	TLV_BASIC_2 CHANNEL_TYPE_2_BS_EIRP;
	TLV_BASIC_4 CHANNEL_TYPE_3_Frame_duration;
	TLV_BASIC_1 CHANNEL_TYPE_4_PHY_Type;
	TLV_BASIC_1 CHANNEL_TYPE_5_Power_adjustment_rule;
	TLV_BASIC_1 CHANNEL_TYPE_6_Channel_Nr;
	TLV_BASIC_1 CHANNEL_TYPE_7_TTG;
	TLV_BASIC_1 CHANNEL_TYPE_8_RTG;
	TLV_BASIC_2 CHANNEL_TYPE_9_RSSIR_MAX;
	TLV_BASIC_3 CHANNEL_TYPE_10_Channel_Switch_Frame_Number;
	TLV_BASIC_4 CHANNEL_TYPE_12_Frequency;
	TLV_BASIC_6 CHANNEL_TYPE_13_BS_ID;
	TLV_BASIC_1 CHANNEL_TYPE_14_Frame_Duration_Code;
	TLV_BASIC_3 CHANNEL_TYPE_15_Frame_Number;
	TLV_BASIC_1 CHANNEL_TYPE_16_Size_of_CQICH_ID_field;
	TLV_BASIC_1 CHANNEL_TYPE_17_H_ARQ_ACK_delay_for_DL_burst;
	TLV_BASIC_1 CHANNEL_TYPE_148_MAC_version;	

	TLV_BASIC_4 PHYcommon_TYPE_1_Frequency;

	TLV_SPEC_DCD_DBP_SC 	Downlink_BP_TYPE_SC;
	TLV_SPEC_DCD_DBP_SCa 	Downlink_BP_TYPE_SCa;
	TLV_SPEC_DCD_DBP_OFDM 	Downlink_BP_TYPE_OFDM;
	TLV_SPEC_DCD_DBP_OFDMA Downlink_BP_TYPE_OFDMA;
	
}TLV_SPEC_DCD;


/* Table 365XSCa-specific RNG-REQ message encodings */
typedef struct{
	TLV_BASIC_6 TYPE_150_SCa_AAS_feedback;

}TLV_SPEC_RNG_REQ_PHY_SCa;


/* 11.5 RNG-REQ management message encodings */
typedef struct{
	TLV_BASIC_1 MESSAGE_TYPE_1_Requested_Downlink_Burst_Profile;
	TLV_BASIC_6 MESSAGE_TYPE_2_SS_MAC_Address;
	TLV_BASIC_1 MESSAGE_TYPE_3_Ranging_Anomalies;
	TLV_BASIC_1 MESSAGE_TYPE_4_AAS_broadcast_capability;

	TLV_SPEC_RNG_REQ_PHY_SCa PHYspec_TYPE_SCa;
	
}TLV_SPEC_RNG_REQ;
	

/* Table 366XSCa-specific RNG-RSP message encodings */
typedef struct{
	TLV_BASIC_1 TYPE_150_AAS_preamble_index;
		
}TLV_SPEC_RNG_RSP_PHY_SCa;


/* Table 368XOFDM-specific RNG-RSP message encodings */
typedef struct{
	TLV_BASIC_1 TYPE_150_Ranging_subchannel;
		
}TLV_SPEC_RNG_RSP_PHY_OFDM;


/* Table 369XOFDMA-specific RNG-RSP message encodings */
typedef struct{
	TLV_BASIC_4 TYPE_150_Ranging_code_attributes;
		
}TLV_SPEC_RNG_RSP_PHY_OFDMA;


/* 11.6 RNG-RSP management message encodings */
typedef struct{
	TLV_BASIC_4 MESSAGE_TYPE_1_Timing_Adjust;
	TLV_BASIC_1 MESSAGE_TYPE_2_Power_Level_Adjust;
	TLV_BASIC_4 MESSAGE_TYPE_3_Offset_Frequency_Adjust;
	TLV_BASIC_1 MESSAGE_TYPE_4_Ranging_Status;
	TLV_BASIC_4 MESSAGE_TYPE_5_Downlink_frequency_override;
	TLV_BASIC_1 MESSAGE_TYPE_6_Uplink_channel_ID_override;
	TLV_BASIC_2 MESSAGE_TYPE_7_Downlink_Operational_Burst_Profile;
	TLV_BASIC_6 MESSAGE_TYPE_8_SS_MAC_Address;
	TLV_BASIC_2 MESSAGE_TYPE_9_Basic_CID;
	TLV_BASIC_2 MESSAGE_TYPE_10_Primary_Management_CID;
	TLV_BASIC_1 MESSAGE_TYPE_11_AAS_broadcast_permission;
	TLV_BASIC_3 MESSAGE_TYPE_12_Frame_number;
	TLV_BASIC_1 MESSAGE_TYPE_13_Initial_ranging_opportunity_number;

	TLV_SPEC_RNG_RSP_PHY_SCa 	PHYspec_TYPE_SCa;
	TLV_SPEC_RNG_RSP_PHY_OFDM	PHYspec_TYPE_OFDM;
	TLV_SPEC_RNG_RSP_PHY_OFDMA PHYspec_TYPE_OFDMA;
		
}TLV_SPEC_RNG_RSP;


typedef struct{ // pointer to service flow
//	u_int16_t FLAG;
	u_int8_t LENGTH;

	TLV_BASIC_1 *TYPE_18_ARQ_Enable;								// TLV_SPEC_SERVICE_FLOW -> TYPE_18_ARQ_Enable
	TLV_BASIC_2 *TYPE_19_ARQ_WINDOW_SIZE;						// TLV_SPEC_SERVICE_FLOW -> TYPE_19_ARQ_WINDOW_SIZE
	TLV_BASIC_2 *TYPE_20_ARQ_RETRY_TIMEOUT_Transmitter_Delay;	// TLV_SPEC_SERVICE_FLOW -> TYPE_20_ARQ_RETRY_TIMEOUT_Transmitter_Delay
	TLV_BASIC_2 *TYPE_21_ARQ_RETRY_TIMEOUT_Receiver_Delay;		// TLV_SPEC_SERVICE_FLOW -> TYPE_21_ARQ_RETRY_TIMEOUT_Receiver_Delay
	TLV_BASIC_2 *TYPE_22_ARQ_BLOCK_LIFETIME;						// TLV_SPEC_SERVICE_FLOW -> TYPE_22_ARQ_BLOCK_LIFETIME
	TLV_BASIC_2 *TYPE_23_ARQ_SYNC_LOSS;							// TLV_SPEC_SERVICE_FLOW -> TYPE_23_ARQ_SYNC_LOSS
	TLV_BASIC_1 *TYPE_24_ARQ_DELIVER_IN_ORDER;					// TLV_SPEC_SERVICE_FLOW -> TYPE_24_ARQ_DELIVER_IN_ORDER
	TLV_BASIC_2 *TYPE_25_ARQ_PURGE_TIMEOUT;						// TLV_SPEC_SERVICE_FLOW -> TYPE_25_ARQ_PURGE_TIMEOUT
	TLV_BASIC_2 *TYPE_26_ARQ_BLOCK_SIZE; 							// TLV_SPEC_SERVICE_FLOW -> TYPE_26_ARQ_BLOCK_SIZE
}TLV_SPEC_REG_XXX_ARQ; 


/* 11.7 REG-REQ/RSP management message encodings */
typedef struct{
	TLV_SPEC_REG_XXX_ARQ TYPE_1_ARQ_Parameters; // 11.13.18
	TLV_BASIC_1 TYPE_2_SS_management_support;
	TLV_BASIC_1 TYPE_3_IP_management_mode;
	TLV_BASIC_1 TYPE_4_IP_version;
	TLV_BASIC_2 TYPE_5_Secondary_Management_CID;
	TLV_BASIC_2 TYPE_6_Number_of_uplink_CID_supported;
	TLV_BASIC_2 TYPE_7_Classification_PHS_options_and_SDU_encapsulation_support;
	TLV_BASIC_2 TYPE_8_Maximum_number_of_classifiers;
	TLV_BASIC_2 TYPE_9_PHS_support;
	TLV_BASIC_1 TYPE_10_ARQ_Support;
	TLV_BASIC_1 TYPE_11_DSx_flow_control;
	TLV_BASIC_1 TYPE_12_MAC_CRC_support;
	TLV_BASIC_1 TYPE_13_MCA_flow_control;
	TLV_BASIC_1 TYPE_14_Multicast_polling_group_CID_support;
	TLV_BASIC_1 TYPE_15_PKM_flow_control;
	TLV_BASIC_1 TYPE_16_Authorization_Policy_Support;
	TLV_BASIC_1 TYPE_17_Maximum_number_of_supported_security_associations;
	
}TLV_SPEC_REG_XXX;


/* 11.8.3.4 WirelessMAN-SC specific parameters */
typedef struct{
	TLV_BASIC_1 TYPE_150_SC_SS_demodulator_types;
	TLV_BASIC_1 TYPE_151_SC_SS_modulator_types;
	TLV_BASIC_1 TYPE_152_SC_SS_downlink_FEC_types;
	TLV_BASIC_1 TYPE_153_SC_SS_uplink_FEC_types;
	
}TLV_SPEC_SBC_PHY_SC;


/* 11.8.3.5 WirelessMAN-SCa specific parameters */
typedef struct{
	TLV_BASIC_1 TYPE_150_SCa_SS_demodulation_types;
	TLV_BASIC_1 TYPE_151_SCa_SS_demodulator_roll_off_factor;
	TLV_BASIC_1 TYPE_152_SCa_SS_demodulator_Unique_Word_length;
	TLV_BASIC_1 TYPE_153_SCa_SS_demodulator_block_interleaver_depth;
	TLV_BASIC_1 TYPE_155_SCa_SS_demodulator_STC_block_size;
	TLV_BASIC_1 TYPE_156_SCa_SS_modulation_types;
	TLV_BASIC_1 TYPE_157_SCa_SS_modulator_roll_off_factor;
	TLV_BASIC_1 TYPE_158_SCa_SS_modulator_unique_word_length;
	TLV_BASIC_1 TYPE_159_SCa_SS_modulator_block_interleaver_depth;
	TLV_BASIC_1 TYPE_161_SCa_SS_modulator_STC_block_size;
	TLV_BASIC_2 TYPE_162_SCa_SS_modulator_maximum_uplink_channel_width;
	TLV_BASIC_2 TYPE_163_SCa_SS_modulator_minimum_uplink_channel_width;
	TLV_BASIC_3 TYPE_164_SCa_SS_modulator_power_control_limits;
	TLV_BASIC_1 TYPE_165_SCa_SS_modulator_Subchannel_framing_support;
	TLV_BASIC_5 TYPE_166_SCa_maximum_transmit_power;

}TLV_SPEC_SBC_PHY_SCa;


/* 11.8.3.6 WirelessMAN-OFDM specific parameters */
typedef struct{
	TLV_BASIC_1 TYPE_150_OFDM_SS_FFT_sizes;
	TLV_BASIC_1 TYPE_151_OFDM_SS_demodulator;
	TLV_BASIC_1 TYPE_152_OFDM_SS_modulator;
	TLV_BASIC_1 TYPE_153_OFDM_SS_focused_contention_support;
	TLV_BASIC_1 TYPE_154_OFDM_SS_TC_sublayer_support;

}TLV_SPEC_SBC_PHY_OFDM;
	

/* 11.8.3.7 WirelessMAN-OFDMA specific parameters */
typedef struct{
	TLV_BASIC_1 TYPE_150_OFDMA_SS_FFT_sizes;
	TLV_BASIC_1 TYPE_151_OFDMA_SS_demodulator;
	TLV_BASIC_1 TYPE_152_OFDMA_SS_modulator;
	TLV_BASIC_1 TYPE_153_OFDMA_SS_modulator;
	TLV_BASIC_1 TYPE_154_OFDMA_SS_Permutation_support;
	
}TLV_SPEC_SBC_PHY_OFDMA;


/* 11.8 SBC-REQ/RSP management message encodings */
typedef struct{
	TLV_BASIC_1 TYPE_1_Bandwidth_Allocation_Support;
	TLV_BASIC_2 TYPE_2_Subscriber_transition_gaps;
	TLV_BASIC_4 TYPE_3_Maximum_transmit_power;
	TLV_BASIC_1 TYPE_4_Capabilities_for_Construction_and_Transmission_of_MAC_PDUs;
	TLV_BASIC_1 *TYPE_147_Current_transmit_power;  // TLVDB_COMMON_ENCODING -> TYPE_147_Current_transmit_power

	TLV_SPEC_SBC_PHY_SC 	PHYspec_TYPE_SC;
	TLV_SPEC_SBC_PHY_SCa 	PHYspec_TYPE_SCa;
	TLV_SPEC_SBC_PHY_OFDM 	PHYspec_TYPE_OFDM;
	TLV_SPEC_SBC_PHY_OFDMA PHYspec_TYPE_OFDMA;
	
}TLV_SPEC_SBC_XXX;


/* 11.9.19 PKM configuration settings */
typedef struct{
//	u_int16_t FLAG;
	u_int8_t LENGTH;

	TLV_BASIC_4 TYPE_1_Authorize_wait_timeout;
	TLV_BASIC_4 TYPE_2_Reauthorize_wait_timeout;
	TLV_BASIC_4 TYPE_3_Authorization_grace_time;
	TLV_BASIC_4 TYPE_4_Operational_wait_timeout;
	TLV_BASIC_4 TYPE_5_Rekey_wait_timeout;
	TLV_BASIC_4 TYPE_6_TEK_grace_time;
	TLV_BASIC_4 TYPE_7_Authorize_reject_wait_timeout;
	
}TLV_SPEC_PKM_CONFIG;


/* 11.9 PKM-REQ/RSP management message encodings */
typedef struct{
//	TYPE_0~5_reserved;
	TLV_BASIC_V 	TYPE_6_Display_String;
	TLV_BASIC_128 	TYPE_7_AUTH_Key;
	TLV_BASIC_8 	TYPE_8_TEK;
	TLV_BASIC_4 	TYPE_9_Key_Lifetime;
	TLV_BASIC_1 	TYPE_10_Key_Sequence_Number;
	TLV_BASIC_20	TYPE_11_HMAC_Digest;
	TLV_BASIC_2 	TYPE_12_SAID;	
//	preparing			TYPE_13_TEK_Parameters;
//	preparing			TYPE_14_reserved;
	TLV_BASIC_V 	TYPE_15_CBC_IV;
	TLV_BASIC_1 	TYPE_16_Error_Code;
//	preparing			TYPE_17_CA_Certificate;
//	preparing			TYPE_18_SS_Certificate;
//	preparing			TYPE_19_Security_Capabilities;
	TLV_BASIC_3 	TYPE_20_Cryptographic_Suite;
//	preparing			TYPE_21_Cryptographic_Suite_List;
	TLV_BASIC_1 	TYPE_22_Version;
//	preparing			TYPE_23_SA_Descriptor;
	TLV_BASIC_1 	TYPE_24_SA_Type;
//	preparing			TYPE_25_reserved;
//	preparing			TYPE_26_reserved;
	TLV_SPEC_PKM_CONFIG TYPE_27_PKM_Configuration_Settings;
//	preparing			TYPE_28~255_reserved;

}TLV_SPEC_PKM_XXX;


/* 11.10 MCA-REQ management message encodings */
typedef struct{
	TLV_BASIC_2 TYPE_1_Multicast_CID;
	TLV_BASIC_1 TYPE_2_Assignment;
	TLV_BASIC_1 TYPE_3_Multicast_group_type;
	TLV_BASIC_4 TYPE_4_Periodic_allocation_parameters;
	TLV_BASIC_1 TYPE_5_Periodic_allocation_type;
	TLV_BASIC_1 TYPE_6_Operation;
//	preparing		TYPE_7~255_reserved;
	
}TLV_SPEC_MCA_REQ;


/* 11.11 REP-REQ management message encodings */
typedef struct{
//	u_int16_t FLAG;
	u_int8_t LENGTH;

	TLV_BASIC_1 TYPE_1_Report_type;
	TLV_BASIC_1 TYPE_2_Channel_number;
	TLV_BASIC_1 TYPE_3_Channel_Type_request;

}TLV_SPEC_REP_REQ_SUB_1;


/* 11.11 REP-REQ management message encodings */
typedef struct{
	TLV_SPEC_REP_REQ_SUB_1 TYPE_1_Report_request;
	
}TLV_SPEC_REP_REQ;


/* 11.12 REP-RSP management message encodings */
typedef struct{
//	u_int16_t FLAG;
	u_int8_t LENGTH;

	TLV_BASIC_1 TYPE_1_Channel_number;
	TLV_BASIC_2 TYPE_2_Start_frame;
	TLV_BASIC_3 TYPE_3_Duration;
	TLV_BASIC_1 TYPE_4_Basic_report;
	TLV_BASIC_2 TYPE_5_CINR_report;
	TLV_BASIC_2 TYPE_6_RSSI_report;
	
}TLV_SPEC_REP_RSP_SUB_1;	


/* 11.12 REP-RSP management message encodings */
typedef struct{
//	u_int16_t FLAG;
	u_int8_t LENGTH;

	TLV_BASIC_1 TYPE_1_Normal_subchannel_Report;
	TLV_BASIC_4 TYPE_2_Band_AMC_Report;
	TLV_BASIC_5 TYPE_3_Safety_Channel_Report;	
	
}TLV_SPEC_REP_RSP_SUB_2;	


/* 11.12 REP-RSP management message encodings */
typedef struct{
	TLV_SPEC_REP_RSP_SUB_1 	TYPE_1_Report;
	TLV_SPEC_REP_RSP_SUB_1 	TYPE_2_Channel_Type_Report_in_WirelessMAN_OFDMA_PHY;
	TLV_BASIC_1 			*TYPE_147_Current_transmitted_power; // TLVDB_COMMON_ENCODING -> TYPE_147_Current_transmit_power
	
}TLV_SPEC_REP_RSP;


// 쾹ܼƪƵcݭnW߫ŧi ex. REG_REQ, REG_RSP,  ......
struct TLVDB_MAC_MANAGEMENT{
	TLV_SPEC_UCD 		MAC_TYPE_0_UCD;
	TLV_SPEC_DCD 		MAC_TYPE_1_DCD;
	TLV_SPEC_RNG_REQ 	MAC_TYPE_4_RNG_REQ;
	TLV_SPEC_RNG_RSP 	MAC_TYPE_5_RNG_RSP;
	TLV_SPEC_REG_XXX   	*MAC_TYPE_6_REG_REQ; //   use the same variable with MAC_TYPE_7_REG_RSP
	TLV_SPEC_REG_XXX	*MAC_TYPE_7_REG_RSP; //   use the same variable with MAC_TYPE_6_REG_REQ
	TLV_SPEC_PKM_XXX	*MAC_TYPE_9_PKM_REQ;
	TLV_SPEC_PKM_XXX	*MAC_TYPE_10_PKM_RSP;
	TLV_SPEC_MCA_REQ	MAC_TYPE_21_MCA_REQ;
	TLV_SPEC_SBC_XXX 	*MAC_TYPE_26_SBC_REQ; //   use the same variable with MAC_TYPE_27_SBC_RSP
	TLV_SPEC_SBC_XXX 	*MAC_TYPE_27_SBC_RSP; //   use the same variable with MAC_TYPE_26_SBC_REQ
	TLV_SPEC_REP_REQ	MAC_TYPE_36_REP_REQ;
	TLV_SPEC_REP_RSP	MAC_TYPE_37_REP_RSP;
	
};

/*******************************************************************************

		TLV Data Base - Main Structure

********************************************************************************/

struct TLVDB{  
	/* Main Data Base, ҦƭȪsb */
	struct TLVDB_MAC_MANAGEMENT  MAC;		//  Mac Management 
	struct TLVDB_CONFIGURATION_FILE CONFIG;  // Configuration File PART
	struct TLVDB_COMMON_ENCODING 	COMMON;  // Common Encoding PART


	/* Data Base һݪܼ,  Air Management bTLVDB lƮɡANUCܼƦ}J Main Data Base 쾹 */
	
	// TLVDB_COMMON_ENCODING-> *TYPE_145_Uplink_service_flow & *TYPE_146_Downlink_service_flow  Vܼ
	TLV_SPEC_SERVICE_FLOW SERVICE_FLOW;

	// TLVDB_MAC_MANAGEMENT-> *MAC_TYPE_6_REG_REQ  & *MAC_TYPE_7_REG_RSP Vܼ	
	TLV_SPEC_REG_XXX REG_XXX; 

	// TLVDB_MAC_MANAGEMENT-> *MAC_TYPE_9_PKM_REQ & *MAC_TYPE_10_PKM_RSP Vܼ	
	TLV_SPEC_PKM_XXX PKM_XXX;

	// TLVDB_MAC_MANAGEMENT-> *MAC_TYPE_26_SBC_REQ & *MAC_TYPE_27_SBC_RSP Vܼ
	TLV_SPEC_SBC_XXX SBC_XXX;


	/* System Issue, Air Management Use */
//	struct TLVDB_MAC_MANAGEMENT 	*MACptr;
//	struct TLVDB_COMMON_ENCODING 	*CEptr;
//	struct TLVDB_CONFIGURATION_FILE 	*CFptr;
	
};
/***banish***banish***banish***banish***banish***banish***banish***banish***banish***banish***banish***/
 typedef struct {       
      u_int8_t subcode    : 4 __attribute__ ((packed));
      u_int8_t length     : 4 __attribute__ ((packed));
 }UL_EXTENDED_IE;
 



//CDMA Allocation IE pp.534 Table 290
struct CDMA_Allocation_IE{
		u_int8_t Duration						:6  __attribute__ ((packed)); 
		u_int8_t Repetition_Coding_Indication	:2 __attribute__ ((packed)); 
		u_int8_t Ranging_Code;
		u_int8_t Ranging_Symbol;
		u_int8_t Ranging_Subchannel				:7 __attribute__ ((packed)); 
		bool BW_request_mandatory;
}__attribute__ ((packed));

//OFD<A ULMAP extended IE pp.535 Table 291
struct UL_Extended_IE{
		u_int8_t Extend_UIUC:4  __attribute__ ((packed)); 
		u_int8_t Length:4  __attribute__ ((packed));
		//Unspecified data
} __attribute__ ((packed));

//UCD
/*class UCD_MSG{
    public:
		u_int8_t management_msg_type;
		u_int8_t config_change_count;   
		u_int8_t ranging_backoff_start;
		u_int8_t ranging_backoff_end;
		u_int8_t request_backoff_start;
		u_int8_t request_backoff_end;
		TLVDB_MAC_MANAGEMENT UCD;
//      u_int32_t allocation_start_time;
		void init();
	  
	  	static int offset_;	// offset for this header
		inline static int& offset() { return offset_; }
		inline static UCD_MSG* access(const Packet* p) {
		return (UCD_MSG*) p->access(offset_);
		}
 };*/
 

 
class MSH_NCFG_MSG{
	public:
	  u_int8_t management_msg_type;
      u_int8_t numnbrentries: 5 __attribute__ ((packed));				//5bits
	  u_int8_t numbsentries: 2 __attribute__ ((packed));				//2bits
	  u_int8_t embedded_packet_flag: 1 __attribute__ ((packed));		//1bits
	  u_int8_t xmt_power: 4 __attribute__ ((packed));					//4bits
	  u_int8_t xmt_antenna: 3 __attribute__ ((packed));					//3bits	
	  u_int8_t netentry_mac_address_flag: 1 __attribute__ ((packed));	//1bits
      u_int8_t network_base_channel: 4 __attribute__ ((packed));		//4bits
	  u_int8_t reserved: 4 __attribute__ ((packed));					//4bits
	  u_int8_t netconfig_count: 1 __attribute__ ((packed));				//1bits
	  u_int16_t frame_number: 12 __attribute__ ((packed));				//12bits
	  u_int8_t network_control_slot_number_in_frame: 4 __attribute__ ((packed));//4bits
	  u_int8_t synchronization_hop_count: 8 __attribute__ ((packed));	//8bits
	  u_int8_t next_xmt_mx: 3 __attribute__ ((packed));					//3bits
	  u_int8_t xmt_holdoff_exponent: 5 __attribute__ ((packed));		//5bits
	  
  
	  //TLVDB_MAC_MANAGEMENT RNG_RSP;
	  MSH_NCFG_MSG(){
		management_msg_type=39;
	  }	
 };
 
class MSH_NENT_Request_IE{
	public:
		u_int64_t mac_address: 48 __attribute__ ((packed));
		u_int64_t opconfinfo: 64 __attribute__ ((packed));
		u_int32_t operator_authentication_value: 32 __attribute__ ((packed));
		u_int32_t node_serial_number: 32 __attribute__ ((packed));
		
};
 class MSH_NENT{
	public:
		u_int8_t management_msg_type: 8 __attribute__ ((packed));
		u_int8_t type: 3 __attribute__ ((packed));
		u_int8_t xmt_counter_for_this_type: 3 __attribute__ ((packed));
		u_int8_t reserved: 2 __attribute__ ((packed));
		u_int16_t sponsor_node_id: 16 __attribute__ ((packed));
		u_int8_t xmt_power: 4 __attribute__ ((packed));
		u_int8_t xmt_antenna: 3 __attribute__ ((packed));
		u_int8_t reserve: 1 __attribute__ ((packed));
		MSH_NENT(){
			management_msg_type=40;
			//if(type == 0x2)  MSH_NENT_Request_IE ie;			
		}

 };
 
 class MSH_CSCH{
	public:
		u_int8_t management_msg_type: 8 __attribute__ ((packed));
		u_int8_t configuration_sequence_number: 3 __attribute__ ((packed));
		u_int8_t grant_request_flag: 1 __attribute__ ((packed));
		u_int8_t frame_schedule_flag: 1 __attribute__ ((packed));
		u_int8_t configuration_flag: 1 __attribute__ ((packed));
		u_int8_t reserved: 2 __attribute__ ((packed));
		u_int8_t numflowentries: 8 __attribute__ ((packed));
		MSH_CSCH(){
			management_msg_type = 42;
			//for (i=0; i< NumFlowEntries; ++i) {
			//UplinkFlow 4 bits
			//if (Grant / Request Flag == 0)
			//DownlinkFlow 4 bits
			//}
		}

		//BWtraffic to BS UplinkFlow = . 2Flowscale Exponent+14 bits/s
		//BWtraffic from BS DownlinkFlow 2Flowscale Exponent+14 = . bits/s
 };
 
/***banish***banish***banish***banish***banish***banish***banish***banish***banish***banish***banish***/


//MAC Management messages
//榡G1.classŧi 2.غclwƭ
//Table 15. DCD message format	pp.45
//DL Burst Profile-OFMDA
/*class Downlink_Burst_Profile{
	friend class DCD_MSG;
	friend class Mac802_16;
	public:
		u_int8_t Type;
		u_int8_t Length;
		//reserved
		u_int8_t DIUC: 4 __attribute__ ((packed));					//4bits
		TLVDB_MAC_MANAGEMENT DL_Burst_Profile;
//		Downlink_Burst_Profile *link;
};

//UL Burst Profile-OFMDA
class Uplink_Burst_Profile{
	friend class UCD_MSG;
	public:
		u_int8_t Type;
		u_int8_t Length;
		//reserved
		u_int8_t UIUC: 4 __attribute__ ((packed));					//4bits
		TLVDB_MAC_MANAGEMENT UL_Burst_Profile;
};

class DCD_MSG{
	friend class Mac802_16;
	public:
	//	DCD_MSG();
		//Downlink_Burst_Profile dl_burst[17]=new Downlink_Burst_Profile[17];		
		//};
		u_int8_t management_msg_type;
		u_int8_t downlink_channel_ID;
		u_int8_t config_change_count;
		TLVDB_MAC_MANAGEMENT DCD;
//		Downlink_Burst_Profile dl_burst;
		
		
		void init();
		
		static int offset_;	// offset for this header
		inline static int& offset() { return offset_; }
		inline static DCD_MSG* access(const Packet* p) {
		return (DCD_MSG*) p->access(offset_);
		}

		
 };*/
 
struct hdr_mac802_16{
    int ptype; 
    int srcAddr;
    int dstAddr;
	int HT;
	int EC;
	int type;
	int BR;
	int CI;
	int EKS;
	int LEN;
	int CID;
	int HCS;
	int mmt;
	/*
		the following is the packet access function, use this function to access the header in the given packet
	*/
	static int offset_;	// offset for this header
	inline static int& offset() { return offset_; }
	inline static hdr_mac802_16* access(const Packet* p) {
		return (hdr_mac802_16*) p->access(offset_);
	}
};

struct pack_subheader_t{
   u_int32_t Length      : 11  __attribute__ ((packed));
   u_int32_t FSN         : 3   __attribute__ ((packed));
   u_int32_t FC          : 2   __attribute__ ((packed));
 	static int offset_;	// offset for this header
	inline static int& offset() { return offset_; }
	inline static pack_subheader_t* access(const Packet* p) {
		return (pack_subheader_t*) p->access(offset_);
	}     
} __attribute__ ((packed));
struct frag_subheader_t{
   u_int32_t Reserved    : 3   __attribute__ ((packed));
   u_int32_t FSN         : 3   __attribute__ ((packed));
   u_int32_t FC          : 2   __attribute__ ((packed));
	static int offset_;	// offset for this header
	inline static int& offset() { return offset_; }
	inline static frag_subheader_t* access(const Packet* p) {
		return (frag_subheader_t*) p->access(offset_);
	}  
} __attribute__ ((packed));

struct bw_req_t{
   u_int32_t BR   	: 13   __attribute__ ((packed));
   u_int16_t CID    : 16   __attribute__ ((packed));
   u_int8_t EC 		: 1    __attribute__ ((packed));
   u_int8_t HCS		: 8    __attribute__ ((packed));
   u_int8_t HT 		: 1    __attribute__ ((packed));
   u_int8_t Type	: 3    __attribute__ ((packed));
	static int offset_;	
	inline static int& offset() { return offset_; }
	inline static bw_req_t* access(const Packet* p) {
		return (bw_req_t*) p->access(offset_);
	}   
} __attribute__ ((packed));

struct rng_rsp_t{
	u_int8_t mmt				: 8	 __attribute__ ((packed));
	u_int8_t uplinkchannelid	: 8  __attribute__ ((packed));
	u_int16_t SSMAC				: 16 __attribute__ ((packed));
	u_int8_t RNGstatus			: 8  __attribute__ ((packed));
	u_int8_t BasicCID			: 8  __attribute__ ((packed));
	u_int8_t PriManCID			: 8  __attribute__ ((packed));	
	u_int8_t FrameNum			: 8  __attribute__ ((packed));
	u_int8_t IniRNGOpp			: 8  __attribute__ ((packed));
	static int offset_;	
	inline static int& offset() { return offset_; }
	inline static rng_rsp_t* access(const Packet* p) {
		return (rng_rsp_t*) p->access(offset_);
	}
} __attribute__ ((packed));

struct rng_req_t{
	u_int8_t downlinkchannelid	: 8  __attribute__ ((packed));
	u_int8_t mmt				: 8  __attribute__ ((packed));
	u_int8_t ReqDownlinkBurPro	: 8  __attribute__ ((packed));
	u_int16_t ssMACAddr			: 16 __attribute__ ((packed));
	u_int8_t MACver				: 8  __attribute__ ((packed));	
	static int offset_;	
	inline static int& offset() { return offset_; }
	inline static rng_req_t* access(const Packet* p) {
		return (rng_req_t*) p->access(offset_);
	}	
} __attribute__ ((packed));

//ULMAP pp.48 Table 18
struct UL_MAP{
	u_int8_t management_message_type	:8  __attribute__ ((packed));
	u_int8_t uplink_channel_id			:8  __attribute__ ((packed));
	u_int8_t ucd_count					:8  __attribute__ ((packed));
	u_int64_t allocation_start_time		:64 __attribute__ ((packed));	
	
	static int offset_;
	inline static int& offset() { return offset_; }
	inline static UL_MAP* access(const Packet* p) {
	return (UL_MAP*) p->access(offset_);
	}
} __attribute__ ((packed));

//ULMAP IE pp.532 Table 287
struct UL_MAP_IE{
	u_int16_t CID 				: 16 __attribute__ ((packed));
    u_int8_t UIUC				: 4  __attribute__ ((packed)); 
	u_int8_t OFDMA_Symbol_offset: 8  __attribute__ ((packed)); 
	u_int8_t Subchannel_offset	: 7  __attribute__ ((packed)); 
	u_int8_t OFDMA_Symbol_number: 7  __attribute__ ((packed)); 
	u_int8_t Subchannel_number	: 7  __attribute__ ((packed)); 
	u_int8_t Ranging_Method		: 2  __attribute__ ((packed));
	UL_MAP_IE* next;
};

struct DL_MAP{
		u_int8_t management_message_type	: 2  __attribute__ ((packed));
		u_int8_t dcd_count					: 8  __attribute__ ((packed));
		u_int64_t BS_ID						: 48 __attribute__ ((packed));
		static int offset_;	
		inline static int& offset() { return offset_; }
		inline static DL_MAP* access(const Packet* p) {
			return (DL_MAP*) p->access(offset_);
		}
}__attribute__ ((packed));

struct DL_MAP_IE{
    u_int8_t DIUC							: 4 __attribute__ ((packed)); 
	u_int8_t N_CID							: 8 __attribute__ ((packed));
	u_int16_t CID							: 16 __attribute__ ((packed));
	u_int8_t OFDMA_Symbol_offset			: 8 __attribute__ ((packed));
	u_int8_t Subchannel_offset				: 6 __attribute__ ((packed)); 
	u_int8_t Boosting						: 3 __attribute__ ((packed)); 
	u_int8_t OFDMA_Symbol_number			: 7 __attribute__ ((packed)); 
	u_int8_t Subchannel_number				: 6 __attribute__ ((packed)); 
	u_int8_t Repetition_Coding_Indication	: 2 __attribute__ ((packed)); 
	DL_MAP_IE* next;
};

struct DCD{
		u_int8_t management_message_type	: 8  __attribute__ ((packed));
		u_int8_t downlink_channel_id		: 8  __attribute__ ((packed));
		u_int8_t Configuration_Change_Count	: 8 __attribute__ ((packed));
		static int offset_;	
		inline static int& offset() { return offset_; }
		inline static DCD* access(const Packet* p) {
			return (DCD*) p->access(offset_);
		}
}__attribute__ ((packed));

struct UCD{
		u_int8_t management_message_type	: 8  __attribute__ ((packed));
		u_int8_t Configuration_Change_Count	: 8 __attribute__ ((packed));;
		u_int8_t rng_backoff_start			: 8 __attribute__ ((packed));
		u_int8_t rng_backoff_end 			: 8 __attribute__ ((packed));
		u_int8_t req_backoff_start			: 8 __attribute__ ((packed));
		u_int8_t req_backoff_end			: 8 __attribute__ ((packed));
		static int offset_;	
		inline static int& offset() { return offset_; }
		inline static UCD* access(const Packet* p) {
			return (UCD*) p->access(offset_);
		}
}__attribute__ ((packed));

#endif 	/*ns_packet_16__h */

